# DynamicSecretUpdateVenafi

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**AdminRotationIntervalDays** | Pointer to **int64** | Admin credentials rotation interval (days) | [optional] [default to 0]
**AllowSubdomains** | Pointer to **bool** | Allow subdomains | [optional] 
**AllowedDomains** | Pointer to **[]string** | Allowed domains | [optional] 
**AutoGeneratedFolder** | Pointer to **string** | Auto generated folder | [optional] 
**DeleteProtection** | Pointer to **string** | Protection from accidental deletion of this object [true/false] | [optional] 
**Description** | Pointer to **string** | Description of the object | [optional] 
**EnableAdminRotation** | Pointer to **bool** | Automatic admin credentials rotation | [optional] [default to false]
**Json** | Pointer to **bool** | Set output format to JSON | [optional] [default to false]
**Name** | **string** | Dynamic secret name | 
**NewName** | Pointer to **string** | Dynamic secret name | [optional] 
**ProducerEncryptionKeyName** | Pointer to **string** | Dynamic producer encryption key | [optional] 
**RootFirstInChain** | Pointer to **bool** | Root first in chain | [optional] 
**SignUsingAkeylessPki** | Pointer to **bool** | Use Akeyless PKI issuer or Venafi issuer | [optional] 
**SignerKeyName** | Pointer to **string** | Signer key name | [optional] 
**StorePrivateKey** | Pointer to **bool** | Store private key | [optional] 
**Tags** | Pointer to **[]string** | Add tags attached to this object | [optional] 
**TargetName** | Pointer to **string** | Target name | [optional] 
**Token** | Pointer to **string** | Authentication token (see &#x60;/auth&#x60; and &#x60;/configure&#x60;) | [optional] 
**UidToken** | Pointer to **string** | The universal identity token, Required only for universal_identity authentication | [optional] 
**UserTtl** | Pointer to **string** | User TTL in time.Duration format (2160h / 129600m / etc...). When using sign-using-akeyless-pki certificates created will have this validity period, otherwise the user-ttl is taken from the Validity Period field of the Zone&#39;s&#39; Issuing Template. When using cert-manager it is advised to have a TTL of above 60 days (1440h). For more information - https://cert-manager.io/docs/usage/certificate/ | [optional] [default to "2160h"]
**VenafiAccessToken** | Pointer to **string** | Venafi Access Token to use to access the TPP environment (Relevant when using TPP) | [optional] 
**VenafiApiKey** | Pointer to **string** | Venafi API key | [optional] 
**VenafiBaseurl** | Pointer to **string** | Venafi Baseurl | [optional] 
**VenafiClientId** | Pointer to **string** | Venafi Client ID that was used when the access token was generated | [optional] [default to "akeyless"]
**VenafiRefreshToken** | Pointer to **string** | Venafi Refresh Token to use when the Access Token is expired (Relevant when using TPP) | [optional] 
**VenafiUseTpp** | Pointer to **bool** | Venafi using TPP | [optional] 
**VenafiZone** | Pointer to **string** | Venafi Zone | [optional] 

## Methods

### NewDynamicSecretUpdateVenafi

`func NewDynamicSecretUpdateVenafi(name string, ) *DynamicSecretUpdateVenafi`

NewDynamicSecretUpdateVenafi instantiates a new DynamicSecretUpdateVenafi object
This constructor will assign default values to properties that have it defined,
and makes sure properties required by API are set, but the set of arguments
will change when the set of required properties is changed

### NewDynamicSecretUpdateVenafiWithDefaults

`func NewDynamicSecretUpdateVenafiWithDefaults() *DynamicSecretUpdateVenafi`

NewDynamicSecretUpdateVenafiWithDefaults instantiates a new DynamicSecretUpdateVenafi object
This constructor will only assign default values to properties that have it defined,
but it doesn't guarantee that properties required by API are set

### GetAdminRotationIntervalDays

`func (o *DynamicSecretUpdateVenafi) GetAdminRotationIntervalDays() int64`

GetAdminRotationIntervalDays returns the AdminRotationIntervalDays field if non-nil, zero value otherwise.

### GetAdminRotationIntervalDaysOk

`func (o *DynamicSecretUpdateVenafi) GetAdminRotationIntervalDaysOk() (*int64, bool)`

GetAdminRotationIntervalDaysOk returns a tuple with the AdminRotationIntervalDays field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetAdminRotationIntervalDays

`func (o *DynamicSecretUpdateVenafi) SetAdminRotationIntervalDays(v int64)`

SetAdminRotationIntervalDays sets AdminRotationIntervalDays field to given value.

### HasAdminRotationIntervalDays

`func (o *DynamicSecretUpdateVenafi) HasAdminRotationIntervalDays() bool`

HasAdminRotationIntervalDays returns a boolean if a field has been set.

### GetAllowSubdomains

`func (o *DynamicSecretUpdateVenafi) GetAllowSubdomains() bool`

GetAllowSubdomains returns the AllowSubdomains field if non-nil, zero value otherwise.

### GetAllowSubdomainsOk

`func (o *DynamicSecretUpdateVenafi) GetAllowSubdomainsOk() (*bool, bool)`

GetAllowSubdomainsOk returns a tuple with the AllowSubdomains field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetAllowSubdomains

`func (o *DynamicSecretUpdateVenafi) SetAllowSubdomains(v bool)`

SetAllowSubdomains sets AllowSubdomains field to given value.

### HasAllowSubdomains

`func (o *DynamicSecretUpdateVenafi) HasAllowSubdomains() bool`

HasAllowSubdomains returns a boolean if a field has been set.

### GetAllowedDomains

`func (o *DynamicSecretUpdateVenafi) GetAllowedDomains() []string`

GetAllowedDomains returns the AllowedDomains field if non-nil, zero value otherwise.

### GetAllowedDomainsOk

`func (o *DynamicSecretUpdateVenafi) GetAllowedDomainsOk() (*[]string, bool)`

GetAllowedDomainsOk returns a tuple with the AllowedDomains field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetAllowedDomains

`func (o *DynamicSecretUpdateVenafi) SetAllowedDomains(v []string)`

SetAllowedDomains sets AllowedDomains field to given value.

### HasAllowedDomains

`func (o *DynamicSecretUpdateVenafi) HasAllowedDomains() bool`

HasAllowedDomains returns a boolean if a field has been set.

### GetAutoGeneratedFolder

`func (o *DynamicSecretUpdateVenafi) GetAutoGeneratedFolder() string`

GetAutoGeneratedFolder returns the AutoGeneratedFolder field if non-nil, zero value otherwise.

### GetAutoGeneratedFolderOk

`func (o *DynamicSecretUpdateVenafi) GetAutoGeneratedFolderOk() (*string, bool)`

GetAutoGeneratedFolderOk returns a tuple with the AutoGeneratedFolder field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetAutoGeneratedFolder

`func (o *DynamicSecretUpdateVenafi) SetAutoGeneratedFolder(v string)`

SetAutoGeneratedFolder sets AutoGeneratedFolder field to given value.

### HasAutoGeneratedFolder

`func (o *DynamicSecretUpdateVenafi) HasAutoGeneratedFolder() bool`

HasAutoGeneratedFolder returns a boolean if a field has been set.

### GetDeleteProtection

`func (o *DynamicSecretUpdateVenafi) GetDeleteProtection() string`

GetDeleteProtection returns the DeleteProtection field if non-nil, zero value otherwise.

### GetDeleteProtectionOk

`func (o *DynamicSecretUpdateVenafi) GetDeleteProtectionOk() (*string, bool)`

GetDeleteProtectionOk returns a tuple with the DeleteProtection field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetDeleteProtection

`func (o *DynamicSecretUpdateVenafi) SetDeleteProtection(v string)`

SetDeleteProtection sets DeleteProtection field to given value.

### HasDeleteProtection

`func (o *DynamicSecretUpdateVenafi) HasDeleteProtection() bool`

HasDeleteProtection returns a boolean if a field has been set.

### GetDescription

`func (o *DynamicSecretUpdateVenafi) GetDescription() string`

GetDescription returns the Description field if non-nil, zero value otherwise.

### GetDescriptionOk

`func (o *DynamicSecretUpdateVenafi) GetDescriptionOk() (*string, bool)`

GetDescriptionOk returns a tuple with the Description field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetDescription

`func (o *DynamicSecretUpdateVenafi) SetDescription(v string)`

SetDescription sets Description field to given value.

### HasDescription

`func (o *DynamicSecretUpdateVenafi) HasDescription() bool`

HasDescription returns a boolean if a field has been set.

### GetEnableAdminRotation

`func (o *DynamicSecretUpdateVenafi) GetEnableAdminRotation() bool`

GetEnableAdminRotation returns the EnableAdminRotation field if non-nil, zero value otherwise.

### GetEnableAdminRotationOk

`func (o *DynamicSecretUpdateVenafi) GetEnableAdminRotationOk() (*bool, bool)`

GetEnableAdminRotationOk returns a tuple with the EnableAdminRotation field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetEnableAdminRotation

`func (o *DynamicSecretUpdateVenafi) SetEnableAdminRotation(v bool)`

SetEnableAdminRotation sets EnableAdminRotation field to given value.

### HasEnableAdminRotation

`func (o *DynamicSecretUpdateVenafi) HasEnableAdminRotation() bool`

HasEnableAdminRotation returns a boolean if a field has been set.

### GetJson

`func (o *DynamicSecretUpdateVenafi) GetJson() bool`

GetJson returns the Json field if non-nil, zero value otherwise.

### GetJsonOk

`func (o *DynamicSecretUpdateVenafi) GetJsonOk() (*bool, bool)`

GetJsonOk returns a tuple with the Json field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetJson

`func (o *DynamicSecretUpdateVenafi) SetJson(v bool)`

SetJson sets Json field to given value.

### HasJson

`func (o *DynamicSecretUpdateVenafi) HasJson() bool`

HasJson returns a boolean if a field has been set.

### GetName

`func (o *DynamicSecretUpdateVenafi) GetName() string`

GetName returns the Name field if non-nil, zero value otherwise.

### GetNameOk

`func (o *DynamicSecretUpdateVenafi) GetNameOk() (*string, bool)`

GetNameOk returns a tuple with the Name field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetName

`func (o *DynamicSecretUpdateVenafi) SetName(v string)`

SetName sets Name field to given value.


### GetNewName

`func (o *DynamicSecretUpdateVenafi) GetNewName() string`

GetNewName returns the NewName field if non-nil, zero value otherwise.

### GetNewNameOk

`func (o *DynamicSecretUpdateVenafi) GetNewNameOk() (*string, bool)`

GetNewNameOk returns a tuple with the NewName field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetNewName

`func (o *DynamicSecretUpdateVenafi) SetNewName(v string)`

SetNewName sets NewName field to given value.

### HasNewName

`func (o *DynamicSecretUpdateVenafi) HasNewName() bool`

HasNewName returns a boolean if a field has been set.

### GetProducerEncryptionKeyName

`func (o *DynamicSecretUpdateVenafi) GetProducerEncryptionKeyName() string`

GetProducerEncryptionKeyName returns the ProducerEncryptionKeyName field if non-nil, zero value otherwise.

### GetProducerEncryptionKeyNameOk

`func (o *DynamicSecretUpdateVenafi) GetProducerEncryptionKeyNameOk() (*string, bool)`

GetProducerEncryptionKeyNameOk returns a tuple with the ProducerEncryptionKeyName field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetProducerEncryptionKeyName

`func (o *DynamicSecretUpdateVenafi) SetProducerEncryptionKeyName(v string)`

SetProducerEncryptionKeyName sets ProducerEncryptionKeyName field to given value.

### HasProducerEncryptionKeyName

`func (o *DynamicSecretUpdateVenafi) HasProducerEncryptionKeyName() bool`

HasProducerEncryptionKeyName returns a boolean if a field has been set.

### GetRootFirstInChain

`func (o *DynamicSecretUpdateVenafi) GetRootFirstInChain() bool`

GetRootFirstInChain returns the RootFirstInChain field if non-nil, zero value otherwise.

### GetRootFirstInChainOk

`func (o *DynamicSecretUpdateVenafi) GetRootFirstInChainOk() (*bool, bool)`

GetRootFirstInChainOk returns a tuple with the RootFirstInChain field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetRootFirstInChain

`func (o *DynamicSecretUpdateVenafi) SetRootFirstInChain(v bool)`

SetRootFirstInChain sets RootFirstInChain field to given value.

### HasRootFirstInChain

`func (o *DynamicSecretUpdateVenafi) HasRootFirstInChain() bool`

HasRootFirstInChain returns a boolean if a field has been set.

### GetSignUsingAkeylessPki

`func (o *DynamicSecretUpdateVenafi) GetSignUsingAkeylessPki() bool`

GetSignUsingAkeylessPki returns the SignUsingAkeylessPki field if non-nil, zero value otherwise.

### GetSignUsingAkeylessPkiOk

`func (o *DynamicSecretUpdateVenafi) GetSignUsingAkeylessPkiOk() (*bool, bool)`

GetSignUsingAkeylessPkiOk returns a tuple with the SignUsingAkeylessPki field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetSignUsingAkeylessPki

`func (o *DynamicSecretUpdateVenafi) SetSignUsingAkeylessPki(v bool)`

SetSignUsingAkeylessPki sets SignUsingAkeylessPki field to given value.

### HasSignUsingAkeylessPki

`func (o *DynamicSecretUpdateVenafi) HasSignUsingAkeylessPki() bool`

HasSignUsingAkeylessPki returns a boolean if a field has been set.

### GetSignerKeyName

`func (o *DynamicSecretUpdateVenafi) GetSignerKeyName() string`

GetSignerKeyName returns the SignerKeyName field if non-nil, zero value otherwise.

### GetSignerKeyNameOk

`func (o *DynamicSecretUpdateVenafi) GetSignerKeyNameOk() (*string, bool)`

GetSignerKeyNameOk returns a tuple with the SignerKeyName field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetSignerKeyName

`func (o *DynamicSecretUpdateVenafi) SetSignerKeyName(v string)`

SetSignerKeyName sets SignerKeyName field to given value.

### HasSignerKeyName

`func (o *DynamicSecretUpdateVenafi) HasSignerKeyName() bool`

HasSignerKeyName returns a boolean if a field has been set.

### GetStorePrivateKey

`func (o *DynamicSecretUpdateVenafi) GetStorePrivateKey() bool`

GetStorePrivateKey returns the StorePrivateKey field if non-nil, zero value otherwise.

### GetStorePrivateKeyOk

`func (o *DynamicSecretUpdateVenafi) GetStorePrivateKeyOk() (*bool, bool)`

GetStorePrivateKeyOk returns a tuple with the StorePrivateKey field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetStorePrivateKey

`func (o *DynamicSecretUpdateVenafi) SetStorePrivateKey(v bool)`

SetStorePrivateKey sets StorePrivateKey field to given value.

### HasStorePrivateKey

`func (o *DynamicSecretUpdateVenafi) HasStorePrivateKey() bool`

HasStorePrivateKey returns a boolean if a field has been set.

### GetTags

`func (o *DynamicSecretUpdateVenafi) GetTags() []string`

GetTags returns the Tags field if non-nil, zero value otherwise.

### GetTagsOk

`func (o *DynamicSecretUpdateVenafi) GetTagsOk() (*[]string, bool)`

GetTagsOk returns a tuple with the Tags field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetTags

`func (o *DynamicSecretUpdateVenafi) SetTags(v []string)`

SetTags sets Tags field to given value.

### HasTags

`func (o *DynamicSecretUpdateVenafi) HasTags() bool`

HasTags returns a boolean if a field has been set.

### GetTargetName

`func (o *DynamicSecretUpdateVenafi) GetTargetName() string`

GetTargetName returns the TargetName field if non-nil, zero value otherwise.

### GetTargetNameOk

`func (o *DynamicSecretUpdateVenafi) GetTargetNameOk() (*string, bool)`

GetTargetNameOk returns a tuple with the TargetName field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetTargetName

`func (o *DynamicSecretUpdateVenafi) SetTargetName(v string)`

SetTargetName sets TargetName field to given value.

### HasTargetName

`func (o *DynamicSecretUpdateVenafi) HasTargetName() bool`

HasTargetName returns a boolean if a field has been set.

### GetToken

`func (o *DynamicSecretUpdateVenafi) GetToken() string`

GetToken returns the Token field if non-nil, zero value otherwise.

### GetTokenOk

`func (o *DynamicSecretUpdateVenafi) GetTokenOk() (*string, bool)`

GetTokenOk returns a tuple with the Token field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetToken

`func (o *DynamicSecretUpdateVenafi) SetToken(v string)`

SetToken sets Token field to given value.

### HasToken

`func (o *DynamicSecretUpdateVenafi) HasToken() bool`

HasToken returns a boolean if a field has been set.

### GetUidToken

`func (o *DynamicSecretUpdateVenafi) GetUidToken() string`

GetUidToken returns the UidToken field if non-nil, zero value otherwise.

### GetUidTokenOk

`func (o *DynamicSecretUpdateVenafi) GetUidTokenOk() (*string, bool)`

GetUidTokenOk returns a tuple with the UidToken field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetUidToken

`func (o *DynamicSecretUpdateVenafi) SetUidToken(v string)`

SetUidToken sets UidToken field to given value.

### HasUidToken

`func (o *DynamicSecretUpdateVenafi) HasUidToken() bool`

HasUidToken returns a boolean if a field has been set.

### GetUserTtl

`func (o *DynamicSecretUpdateVenafi) GetUserTtl() string`

GetUserTtl returns the UserTtl field if non-nil, zero value otherwise.

### GetUserTtlOk

`func (o *DynamicSecretUpdateVenafi) GetUserTtlOk() (*string, bool)`

GetUserTtlOk returns a tuple with the UserTtl field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetUserTtl

`func (o *DynamicSecretUpdateVenafi) SetUserTtl(v string)`

SetUserTtl sets UserTtl field to given value.

### HasUserTtl

`func (o *DynamicSecretUpdateVenafi) HasUserTtl() bool`

HasUserTtl returns a boolean if a field has been set.

### GetVenafiAccessToken

`func (o *DynamicSecretUpdateVenafi) GetVenafiAccessToken() string`

GetVenafiAccessToken returns the VenafiAccessToken field if non-nil, zero value otherwise.

### GetVenafiAccessTokenOk

`func (o *DynamicSecretUpdateVenafi) GetVenafiAccessTokenOk() (*string, bool)`

GetVenafiAccessTokenOk returns a tuple with the VenafiAccessToken field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetVenafiAccessToken

`func (o *DynamicSecretUpdateVenafi) SetVenafiAccessToken(v string)`

SetVenafiAccessToken sets VenafiAccessToken field to given value.

### HasVenafiAccessToken

`func (o *DynamicSecretUpdateVenafi) HasVenafiAccessToken() bool`

HasVenafiAccessToken returns a boolean if a field has been set.

### GetVenafiApiKey

`func (o *DynamicSecretUpdateVenafi) GetVenafiApiKey() string`

GetVenafiApiKey returns the VenafiApiKey field if non-nil, zero value otherwise.

### GetVenafiApiKeyOk

`func (o *DynamicSecretUpdateVenafi) GetVenafiApiKeyOk() (*string, bool)`

GetVenafiApiKeyOk returns a tuple with the VenafiApiKey field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetVenafiApiKey

`func (o *DynamicSecretUpdateVenafi) SetVenafiApiKey(v string)`

SetVenafiApiKey sets VenafiApiKey field to given value.

### HasVenafiApiKey

`func (o *DynamicSecretUpdateVenafi) HasVenafiApiKey() bool`

HasVenafiApiKey returns a boolean if a field has been set.

### GetVenafiBaseurl

`func (o *DynamicSecretUpdateVenafi) GetVenafiBaseurl() string`

GetVenafiBaseurl returns the VenafiBaseurl field if non-nil, zero value otherwise.

### GetVenafiBaseurlOk

`func (o *DynamicSecretUpdateVenafi) GetVenafiBaseurlOk() (*string, bool)`

GetVenafiBaseurlOk returns a tuple with the VenafiBaseurl field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetVenafiBaseurl

`func (o *DynamicSecretUpdateVenafi) SetVenafiBaseurl(v string)`

SetVenafiBaseurl sets VenafiBaseurl field to given value.

### HasVenafiBaseurl

`func (o *DynamicSecretUpdateVenafi) HasVenafiBaseurl() bool`

HasVenafiBaseurl returns a boolean if a field has been set.

### GetVenafiClientId

`func (o *DynamicSecretUpdateVenafi) GetVenafiClientId() string`

GetVenafiClientId returns the VenafiClientId field if non-nil, zero value otherwise.

### GetVenafiClientIdOk

`func (o *DynamicSecretUpdateVenafi) GetVenafiClientIdOk() (*string, bool)`

GetVenafiClientIdOk returns a tuple with the VenafiClientId field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetVenafiClientId

`func (o *DynamicSecretUpdateVenafi) SetVenafiClientId(v string)`

SetVenafiClientId sets VenafiClientId field to given value.

### HasVenafiClientId

`func (o *DynamicSecretUpdateVenafi) HasVenafiClientId() bool`

HasVenafiClientId returns a boolean if a field has been set.

### GetVenafiRefreshToken

`func (o *DynamicSecretUpdateVenafi) GetVenafiRefreshToken() string`

GetVenafiRefreshToken returns the VenafiRefreshToken field if non-nil, zero value otherwise.

### GetVenafiRefreshTokenOk

`func (o *DynamicSecretUpdateVenafi) GetVenafiRefreshTokenOk() (*string, bool)`

GetVenafiRefreshTokenOk returns a tuple with the VenafiRefreshToken field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetVenafiRefreshToken

`func (o *DynamicSecretUpdateVenafi) SetVenafiRefreshToken(v string)`

SetVenafiRefreshToken sets VenafiRefreshToken field to given value.

### HasVenafiRefreshToken

`func (o *DynamicSecretUpdateVenafi) HasVenafiRefreshToken() bool`

HasVenafiRefreshToken returns a boolean if a field has been set.

### GetVenafiUseTpp

`func (o *DynamicSecretUpdateVenafi) GetVenafiUseTpp() bool`

GetVenafiUseTpp returns the VenafiUseTpp field if non-nil, zero value otherwise.

### GetVenafiUseTppOk

`func (o *DynamicSecretUpdateVenafi) GetVenafiUseTppOk() (*bool, bool)`

GetVenafiUseTppOk returns a tuple with the VenafiUseTpp field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetVenafiUseTpp

`func (o *DynamicSecretUpdateVenafi) SetVenafiUseTpp(v bool)`

SetVenafiUseTpp sets VenafiUseTpp field to given value.

### HasVenafiUseTpp

`func (o *DynamicSecretUpdateVenafi) HasVenafiUseTpp() bool`

HasVenafiUseTpp returns a boolean if a field has been set.

### GetVenafiZone

`func (o *DynamicSecretUpdateVenafi) GetVenafiZone() string`

GetVenafiZone returns the VenafiZone field if non-nil, zero value otherwise.

### GetVenafiZoneOk

`func (o *DynamicSecretUpdateVenafi) GetVenafiZoneOk() (*string, bool)`

GetVenafiZoneOk returns a tuple with the VenafiZone field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetVenafiZone

`func (o *DynamicSecretUpdateVenafi) SetVenafiZone(v string)`

SetVenafiZone sets VenafiZone field to given value.

### HasVenafiZone

`func (o *DynamicSecretUpdateVenafi) HasVenafiZone() bool`

HasVenafiZone returns a boolean if a field has been set.


[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


