/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// AuthOutput struct for AuthOutput
type AuthOutput struct {
	CompleteAuthLink *string `json:"complete_auth_link,omitempty"`
	Creds *SystemAccessCredentialsReplyObj `json:"creds,omitempty"`
	Token *string `json:"token,omitempty"`
}

// NewAuthOutput instantiates a new AuthOutput object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAuthOutput() *AuthOutput {
	this := AuthOutput{}
	return &this
}

// NewAuthOutputWithDefaults instantiates a new AuthOutput object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAuthOutputWithDefaults() *AuthOutput {
	this := AuthOutput{}
	return &this
}

// GetCompleteAuthLink returns the CompleteAuthLink field value if set, zero value otherwise.
func (o *AuthOutput) GetCompleteAuthLink() string {
	if o == nil || o.CompleteAuthLink == nil {
		var ret string
		return ret
	}
	return *o.CompleteAuthLink
}

// GetCompleteAuthLinkOk returns a tuple with the CompleteAuthLink field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuthOutput) GetCompleteAuthLinkOk() (*string, bool) {
	if o == nil || o.CompleteAuthLink == nil {
		return nil, false
	}
	return o.CompleteAuthLink, true
}

// HasCompleteAuthLink returns a boolean if a field has been set.
func (o *AuthOutput) HasCompleteAuthLink() bool {
	if o != nil && o.CompleteAuthLink != nil {
		return true
	}

	return false
}

// SetCompleteAuthLink gets a reference to the given string and assigns it to the CompleteAuthLink field.
func (o *AuthOutput) SetCompleteAuthLink(v string) {
	o.CompleteAuthLink = &v
}

// GetCreds returns the Creds field value if set, zero value otherwise.
func (o *AuthOutput) GetCreds() SystemAccessCredentialsReplyObj {
	if o == nil || o.Creds == nil {
		var ret SystemAccessCredentialsReplyObj
		return ret
	}
	return *o.Creds
}

// GetCredsOk returns a tuple with the Creds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuthOutput) GetCredsOk() (*SystemAccessCredentialsReplyObj, bool) {
	if o == nil || o.Creds == nil {
		return nil, false
	}
	return o.Creds, true
}

// HasCreds returns a boolean if a field has been set.
func (o *AuthOutput) HasCreds() bool {
	if o != nil && o.Creds != nil {
		return true
	}

	return false
}

// SetCreds gets a reference to the given SystemAccessCredentialsReplyObj and assigns it to the Creds field.
func (o *AuthOutput) SetCreds(v SystemAccessCredentialsReplyObj) {
	o.Creds = &v
}

// GetToken returns the Token field value if set, zero value otherwise.
func (o *AuthOutput) GetToken() string {
	if o == nil || o.Token == nil {
		var ret string
		return ret
	}
	return *o.Token
}

// GetTokenOk returns a tuple with the Token field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuthOutput) GetTokenOk() (*string, bool) {
	if o == nil || o.Token == nil {
		return nil, false
	}
	return o.Token, true
}

// HasToken returns a boolean if a field has been set.
func (o *AuthOutput) HasToken() bool {
	if o != nil && o.Token != nil {
		return true
	}

	return false
}

// SetToken gets a reference to the given string and assigns it to the Token field.
func (o *AuthOutput) SetToken(v string) {
	o.Token = &v
}

func (o AuthOutput) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.CompleteAuthLink != nil {
		toSerialize["complete_auth_link"] = o.CompleteAuthLink
	}
	if o.Creds != nil {
		toSerialize["creds"] = o.Creds
	}
	if o.Token != nil {
		toSerialize["token"] = o.Token
	}
	return json.Marshal(toSerialize)
}

type NullableAuthOutput struct {
	value *AuthOutput
	isSet bool
}

func (v NullableAuthOutput) Get() *AuthOutput {
	return v.value
}

func (v *NullableAuthOutput) Set(val *AuthOutput) {
	v.value = val
	v.isSet = true
}

func (v NullableAuthOutput) IsSet() bool {
	return v.isSet
}

func (v *NullableAuthOutput) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAuthOutput(val *AuthOutput) *NullableAuthOutput {
	return &NullableAuthOutput{value: val, isSet: true}
}

func (v NullableAuthOutput) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAuthOutput) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


