/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// BastionConfigReplyObj struct for BastionConfigReplyObj
type BastionConfigReplyObj struct {
	ApiGatewayUrl *string `json:"api_gateway_url,omitempty"`
	ClusterId *string `json:"cluster_id,omitempty"`
	GatorClusterId *int64 `json:"gator_cluster_id,omitempty"`
	Global *BastionGlobalConf `json:"global,omitempty"`
	SshBastion *SshBastionConf `json:"ssh_bastion,omitempty"`
	WebBastion *WebBastionConf `json:"web_bastion,omitempty"`
}

// NewBastionConfigReplyObj instantiates a new BastionConfigReplyObj object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBastionConfigReplyObj() *BastionConfigReplyObj {
	this := BastionConfigReplyObj{}
	return &this
}

// NewBastionConfigReplyObjWithDefaults instantiates a new BastionConfigReplyObj object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBastionConfigReplyObjWithDefaults() *BastionConfigReplyObj {
	this := BastionConfigReplyObj{}
	return &this
}

// GetApiGatewayUrl returns the ApiGatewayUrl field value if set, zero value otherwise.
func (o *BastionConfigReplyObj) GetApiGatewayUrl() string {
	if o == nil || o.ApiGatewayUrl == nil {
		var ret string
		return ret
	}
	return *o.ApiGatewayUrl
}

// GetApiGatewayUrlOk returns a tuple with the ApiGatewayUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BastionConfigReplyObj) GetApiGatewayUrlOk() (*string, bool) {
	if o == nil || o.ApiGatewayUrl == nil {
		return nil, false
	}
	return o.ApiGatewayUrl, true
}

// HasApiGatewayUrl returns a boolean if a field has been set.
func (o *BastionConfigReplyObj) HasApiGatewayUrl() bool {
	if o != nil && o.ApiGatewayUrl != nil {
		return true
	}

	return false
}

// SetApiGatewayUrl gets a reference to the given string and assigns it to the ApiGatewayUrl field.
func (o *BastionConfigReplyObj) SetApiGatewayUrl(v string) {
	o.ApiGatewayUrl = &v
}

// GetClusterId returns the ClusterId field value if set, zero value otherwise.
func (o *BastionConfigReplyObj) GetClusterId() string {
	if o == nil || o.ClusterId == nil {
		var ret string
		return ret
	}
	return *o.ClusterId
}

// GetClusterIdOk returns a tuple with the ClusterId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BastionConfigReplyObj) GetClusterIdOk() (*string, bool) {
	if o == nil || o.ClusterId == nil {
		return nil, false
	}
	return o.ClusterId, true
}

// HasClusterId returns a boolean if a field has been set.
func (o *BastionConfigReplyObj) HasClusterId() bool {
	if o != nil && o.ClusterId != nil {
		return true
	}

	return false
}

// SetClusterId gets a reference to the given string and assigns it to the ClusterId field.
func (o *BastionConfigReplyObj) SetClusterId(v string) {
	o.ClusterId = &v
}

// GetGatorClusterId returns the GatorClusterId field value if set, zero value otherwise.
func (o *BastionConfigReplyObj) GetGatorClusterId() int64 {
	if o == nil || o.GatorClusterId == nil {
		var ret int64
		return ret
	}
	return *o.GatorClusterId
}

// GetGatorClusterIdOk returns a tuple with the GatorClusterId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BastionConfigReplyObj) GetGatorClusterIdOk() (*int64, bool) {
	if o == nil || o.GatorClusterId == nil {
		return nil, false
	}
	return o.GatorClusterId, true
}

// HasGatorClusterId returns a boolean if a field has been set.
func (o *BastionConfigReplyObj) HasGatorClusterId() bool {
	if o != nil && o.GatorClusterId != nil {
		return true
	}

	return false
}

// SetGatorClusterId gets a reference to the given int64 and assigns it to the GatorClusterId field.
func (o *BastionConfigReplyObj) SetGatorClusterId(v int64) {
	o.GatorClusterId = &v
}

// GetGlobal returns the Global field value if set, zero value otherwise.
func (o *BastionConfigReplyObj) GetGlobal() BastionGlobalConf {
	if o == nil || o.Global == nil {
		var ret BastionGlobalConf
		return ret
	}
	return *o.Global
}

// GetGlobalOk returns a tuple with the Global field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BastionConfigReplyObj) GetGlobalOk() (*BastionGlobalConf, bool) {
	if o == nil || o.Global == nil {
		return nil, false
	}
	return o.Global, true
}

// HasGlobal returns a boolean if a field has been set.
func (o *BastionConfigReplyObj) HasGlobal() bool {
	if o != nil && o.Global != nil {
		return true
	}

	return false
}

// SetGlobal gets a reference to the given BastionGlobalConf and assigns it to the Global field.
func (o *BastionConfigReplyObj) SetGlobal(v BastionGlobalConf) {
	o.Global = &v
}

// GetSshBastion returns the SshBastion field value if set, zero value otherwise.
func (o *BastionConfigReplyObj) GetSshBastion() SshBastionConf {
	if o == nil || o.SshBastion == nil {
		var ret SshBastionConf
		return ret
	}
	return *o.SshBastion
}

// GetSshBastionOk returns a tuple with the SshBastion field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BastionConfigReplyObj) GetSshBastionOk() (*SshBastionConf, bool) {
	if o == nil || o.SshBastion == nil {
		return nil, false
	}
	return o.SshBastion, true
}

// HasSshBastion returns a boolean if a field has been set.
func (o *BastionConfigReplyObj) HasSshBastion() bool {
	if o != nil && o.SshBastion != nil {
		return true
	}

	return false
}

// SetSshBastion gets a reference to the given SshBastionConf and assigns it to the SshBastion field.
func (o *BastionConfigReplyObj) SetSshBastion(v SshBastionConf) {
	o.SshBastion = &v
}

// GetWebBastion returns the WebBastion field value if set, zero value otherwise.
func (o *BastionConfigReplyObj) GetWebBastion() WebBastionConf {
	if o == nil || o.WebBastion == nil {
		var ret WebBastionConf
		return ret
	}
	return *o.WebBastion
}

// GetWebBastionOk returns a tuple with the WebBastion field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BastionConfigReplyObj) GetWebBastionOk() (*WebBastionConf, bool) {
	if o == nil || o.WebBastion == nil {
		return nil, false
	}
	return o.WebBastion, true
}

// HasWebBastion returns a boolean if a field has been set.
func (o *BastionConfigReplyObj) HasWebBastion() bool {
	if o != nil && o.WebBastion != nil {
		return true
	}

	return false
}

// SetWebBastion gets a reference to the given WebBastionConf and assigns it to the WebBastion field.
func (o *BastionConfigReplyObj) SetWebBastion(v WebBastionConf) {
	o.WebBastion = &v
}

func (o BastionConfigReplyObj) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.ApiGatewayUrl != nil {
		toSerialize["api_gateway_url"] = o.ApiGatewayUrl
	}
	if o.ClusterId != nil {
		toSerialize["cluster_id"] = o.ClusterId
	}
	if o.GatorClusterId != nil {
		toSerialize["gator_cluster_id"] = o.GatorClusterId
	}
	if o.Global != nil {
		toSerialize["global"] = o.Global
	}
	if o.SshBastion != nil {
		toSerialize["ssh_bastion"] = o.SshBastion
	}
	if o.WebBastion != nil {
		toSerialize["web_bastion"] = o.WebBastion
	}
	return json.Marshal(toSerialize)
}

type NullableBastionConfigReplyObj struct {
	value *BastionConfigReplyObj
	isSet bool
}

func (v NullableBastionConfigReplyObj) Get() *BastionConfigReplyObj {
	return v.value
}

func (v *NullableBastionConfigReplyObj) Set(val *BastionConfigReplyObj) {
	v.value = val
	v.isSet = true
}

func (v NullableBastionConfigReplyObj) IsSet() bool {
	return v.isSet
}

func (v *NullableBastionConfigReplyObj) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBastionConfigReplyObj(val *BastionConfigReplyObj) *NullableBastionConfigReplyObj {
	return &NullableBastionConfigReplyObj{value: val, isSet: true}
}

func (v NullableBastionConfigReplyObj) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBastionConfigReplyObj) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


