/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// BatchEncryptionRequestLine struct for BatchEncryptionRequestLine
type BatchEncryptionRequestLine struct {
	Context *map[string]string `json:"context,omitempty"`
	Data *string `json:"data,omitempty"`
	ItemId *int64 `json:"item_id,omitempty"`
	ItemVersion *int32 `json:"item_version,omitempty"`
}

// NewBatchEncryptionRequestLine instantiates a new BatchEncryptionRequestLine object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBatchEncryptionRequestLine() *BatchEncryptionRequestLine {
	this := BatchEncryptionRequestLine{}
	return &this
}

// NewBatchEncryptionRequestLineWithDefaults instantiates a new BatchEncryptionRequestLine object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBatchEncryptionRequestLineWithDefaults() *BatchEncryptionRequestLine {
	this := BatchEncryptionRequestLine{}
	return &this
}

// GetContext returns the Context field value if set, zero value otherwise.
func (o *BatchEncryptionRequestLine) GetContext() map[string]string {
	if o == nil || o.Context == nil {
		var ret map[string]string
		return ret
	}
	return *o.Context
}

// GetContextOk returns a tuple with the Context field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchEncryptionRequestLine) GetContextOk() (*map[string]string, bool) {
	if o == nil || o.Context == nil {
		return nil, false
	}
	return o.Context, true
}

// HasContext returns a boolean if a field has been set.
func (o *BatchEncryptionRequestLine) HasContext() bool {
	if o != nil && o.Context != nil {
		return true
	}

	return false
}

// SetContext gets a reference to the given map[string]string and assigns it to the Context field.
func (o *BatchEncryptionRequestLine) SetContext(v map[string]string) {
	o.Context = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *BatchEncryptionRequestLine) GetData() string {
	if o == nil || o.Data == nil {
		var ret string
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchEncryptionRequestLine) GetDataOk() (*string, bool) {
	if o == nil || o.Data == nil {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *BatchEncryptionRequestLine) HasData() bool {
	if o != nil && o.Data != nil {
		return true
	}

	return false
}

// SetData gets a reference to the given string and assigns it to the Data field.
func (o *BatchEncryptionRequestLine) SetData(v string) {
	o.Data = &v
}

// GetItemId returns the ItemId field value if set, zero value otherwise.
func (o *BatchEncryptionRequestLine) GetItemId() int64 {
	if o == nil || o.ItemId == nil {
		var ret int64
		return ret
	}
	return *o.ItemId
}

// GetItemIdOk returns a tuple with the ItemId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchEncryptionRequestLine) GetItemIdOk() (*int64, bool) {
	if o == nil || o.ItemId == nil {
		return nil, false
	}
	return o.ItemId, true
}

// HasItemId returns a boolean if a field has been set.
func (o *BatchEncryptionRequestLine) HasItemId() bool {
	if o != nil && o.ItemId != nil {
		return true
	}

	return false
}

// SetItemId gets a reference to the given int64 and assigns it to the ItemId field.
func (o *BatchEncryptionRequestLine) SetItemId(v int64) {
	o.ItemId = &v
}

// GetItemVersion returns the ItemVersion field value if set, zero value otherwise.
func (o *BatchEncryptionRequestLine) GetItemVersion() int32 {
	if o == nil || o.ItemVersion == nil {
		var ret int32
		return ret
	}
	return *o.ItemVersion
}

// GetItemVersionOk returns a tuple with the ItemVersion field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchEncryptionRequestLine) GetItemVersionOk() (*int32, bool) {
	if o == nil || o.ItemVersion == nil {
		return nil, false
	}
	return o.ItemVersion, true
}

// HasItemVersion returns a boolean if a field has been set.
func (o *BatchEncryptionRequestLine) HasItemVersion() bool {
	if o != nil && o.ItemVersion != nil {
		return true
	}

	return false
}

// SetItemVersion gets a reference to the given int32 and assigns it to the ItemVersion field.
func (o *BatchEncryptionRequestLine) SetItemVersion(v int32) {
	o.ItemVersion = &v
}

func (o BatchEncryptionRequestLine) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Context != nil {
		toSerialize["context"] = o.Context
	}
	if o.Data != nil {
		toSerialize["data"] = o.Data
	}
	if o.ItemId != nil {
		toSerialize["item_id"] = o.ItemId
	}
	if o.ItemVersion != nil {
		toSerialize["item_version"] = o.ItemVersion
	}
	return json.Marshal(toSerialize)
}

type NullableBatchEncryptionRequestLine struct {
	value *BatchEncryptionRequestLine
	isSet bool
}

func (v NullableBatchEncryptionRequestLine) Get() *BatchEncryptionRequestLine {
	return v.value
}

func (v *NullableBatchEncryptionRequestLine) Set(val *BatchEncryptionRequestLine) {
	v.value = val
	v.isSet = true
}

func (v NullableBatchEncryptionRequestLine) IsSet() bool {
	return v.isSet
}

func (v *NullableBatchEncryptionRequestLine) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBatchEncryptionRequestLine(val *BatchEncryptionRequestLine) *NullableBatchEncryptionRequestLine {
	return &NullableBatchEncryptionRequestLine{value: val, isSet: true}
}

func (v NullableBatchEncryptionRequestLine) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBatchEncryptionRequestLine) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


