/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
	"time"
)

// GenerateAcmeEabOutput struct for GenerateAcmeEabOutput
type GenerateAcmeEabOutput struct {
	ExpiresAt *time.Time `json:"expires_at,omitempty"`
	Kid *string `json:"kid,omitempty"`
	MacKey *string `json:"mac_key,omitempty"`
}

// NewGenerateAcmeEabOutput instantiates a new GenerateAcmeEabOutput object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGenerateAcmeEabOutput() *GenerateAcmeEabOutput {
	this := GenerateAcmeEabOutput{}
	return &this
}

// NewGenerateAcmeEabOutputWithDefaults instantiates a new GenerateAcmeEabOutput object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGenerateAcmeEabOutputWithDefaults() *GenerateAcmeEabOutput {
	this := GenerateAcmeEabOutput{}
	return &this
}

// GetExpiresAt returns the ExpiresAt field value if set, zero value otherwise.
func (o *GenerateAcmeEabOutput) GetExpiresAt() time.Time {
	if o == nil || o.ExpiresAt == nil {
		var ret time.Time
		return ret
	}
	return *o.ExpiresAt
}

// GetExpiresAtOk returns a tuple with the ExpiresAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GenerateAcmeEabOutput) GetExpiresAtOk() (*time.Time, bool) {
	if o == nil || o.ExpiresAt == nil {
		return nil, false
	}
	return o.ExpiresAt, true
}

// HasExpiresAt returns a boolean if a field has been set.
func (o *GenerateAcmeEabOutput) HasExpiresAt() bool {
	if o != nil && o.ExpiresAt != nil {
		return true
	}

	return false
}

// SetExpiresAt gets a reference to the given time.Time and assigns it to the ExpiresAt field.
func (o *GenerateAcmeEabOutput) SetExpiresAt(v time.Time) {
	o.ExpiresAt = &v
}

// GetKid returns the Kid field value if set, zero value otherwise.
func (o *GenerateAcmeEabOutput) GetKid() string {
	if o == nil || o.Kid == nil {
		var ret string
		return ret
	}
	return *o.Kid
}

// GetKidOk returns a tuple with the Kid field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GenerateAcmeEabOutput) GetKidOk() (*string, bool) {
	if o == nil || o.Kid == nil {
		return nil, false
	}
	return o.Kid, true
}

// HasKid returns a boolean if a field has been set.
func (o *GenerateAcmeEabOutput) HasKid() bool {
	if o != nil && o.Kid != nil {
		return true
	}

	return false
}

// SetKid gets a reference to the given string and assigns it to the Kid field.
func (o *GenerateAcmeEabOutput) SetKid(v string) {
	o.Kid = &v
}

// GetMacKey returns the MacKey field value if set, zero value otherwise.
func (o *GenerateAcmeEabOutput) GetMacKey() string {
	if o == nil || o.MacKey == nil {
		var ret string
		return ret
	}
	return *o.MacKey
}

// GetMacKeyOk returns a tuple with the MacKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GenerateAcmeEabOutput) GetMacKeyOk() (*string, bool) {
	if o == nil || o.MacKey == nil {
		return nil, false
	}
	return o.MacKey, true
}

// HasMacKey returns a boolean if a field has been set.
func (o *GenerateAcmeEabOutput) HasMacKey() bool {
	if o != nil && o.MacKey != nil {
		return true
	}

	return false
}

// SetMacKey gets a reference to the given string and assigns it to the MacKey field.
func (o *GenerateAcmeEabOutput) SetMacKey(v string) {
	o.MacKey = &v
}

func (o GenerateAcmeEabOutput) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.ExpiresAt != nil {
		toSerialize["expires_at"] = o.ExpiresAt
	}
	if o.Kid != nil {
		toSerialize["kid"] = o.Kid
	}
	if o.MacKey != nil {
		toSerialize["mac_key"] = o.MacKey
	}
	return json.Marshal(toSerialize)
}

type NullableGenerateAcmeEabOutput struct {
	value *GenerateAcmeEabOutput
	isSet bool
}

func (v NullableGenerateAcmeEabOutput) Get() *GenerateAcmeEabOutput {
	return v.value
}

func (v *NullableGenerateAcmeEabOutput) Set(val *GenerateAcmeEabOutput) {
	v.value = val
	v.isSet = true
}

func (v NullableGenerateAcmeEabOutput) IsSet() bool {
	return v.isSet
}

func (v *NullableGenerateAcmeEabOutput) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGenerateAcmeEabOutput(val *GenerateAcmeEabOutput) *NullableGenerateAcmeEabOutput {
	return &NullableGenerateAcmeEabOutput{value: val, isSet: true}
}

func (v NullableGenerateAcmeEabOutput) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGenerateAcmeEabOutput) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


