/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// GitlabTargetDetails GitlabTargetDetails
type GitlabTargetDetails struct {
	GitlabAccessToken *string `json:"gitlab_access_token,omitempty"`
	GitlabCertificate *string `json:"gitlab_certificate,omitempty"`
	GitlabUrl *string `json:"gitlab_url,omitempty"`
}

// NewGitlabTargetDetails instantiates a new GitlabTargetDetails object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGitlabTargetDetails() *GitlabTargetDetails {
	this := GitlabTargetDetails{}
	return &this
}

// NewGitlabTargetDetailsWithDefaults instantiates a new GitlabTargetDetails object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGitlabTargetDetailsWithDefaults() *GitlabTargetDetails {
	this := GitlabTargetDetails{}
	return &this
}

// GetGitlabAccessToken returns the GitlabAccessToken field value if set, zero value otherwise.
func (o *GitlabTargetDetails) GetGitlabAccessToken() string {
	if o == nil || o.GitlabAccessToken == nil {
		var ret string
		return ret
	}
	return *o.GitlabAccessToken
}

// GetGitlabAccessTokenOk returns a tuple with the GitlabAccessToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GitlabTargetDetails) GetGitlabAccessTokenOk() (*string, bool) {
	if o == nil || o.GitlabAccessToken == nil {
		return nil, false
	}
	return o.GitlabAccessToken, true
}

// HasGitlabAccessToken returns a boolean if a field has been set.
func (o *GitlabTargetDetails) HasGitlabAccessToken() bool {
	if o != nil && o.GitlabAccessToken != nil {
		return true
	}

	return false
}

// SetGitlabAccessToken gets a reference to the given string and assigns it to the GitlabAccessToken field.
func (o *GitlabTargetDetails) SetGitlabAccessToken(v string) {
	o.GitlabAccessToken = &v
}

// GetGitlabCertificate returns the GitlabCertificate field value if set, zero value otherwise.
func (o *GitlabTargetDetails) GetGitlabCertificate() string {
	if o == nil || o.GitlabCertificate == nil {
		var ret string
		return ret
	}
	return *o.GitlabCertificate
}

// GetGitlabCertificateOk returns a tuple with the GitlabCertificate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GitlabTargetDetails) GetGitlabCertificateOk() (*string, bool) {
	if o == nil || o.GitlabCertificate == nil {
		return nil, false
	}
	return o.GitlabCertificate, true
}

// HasGitlabCertificate returns a boolean if a field has been set.
func (o *GitlabTargetDetails) HasGitlabCertificate() bool {
	if o != nil && o.GitlabCertificate != nil {
		return true
	}

	return false
}

// SetGitlabCertificate gets a reference to the given string and assigns it to the GitlabCertificate field.
func (o *GitlabTargetDetails) SetGitlabCertificate(v string) {
	o.GitlabCertificate = &v
}

// GetGitlabUrl returns the GitlabUrl field value if set, zero value otherwise.
func (o *GitlabTargetDetails) GetGitlabUrl() string {
	if o == nil || o.GitlabUrl == nil {
		var ret string
		return ret
	}
	return *o.GitlabUrl
}

// GetGitlabUrlOk returns a tuple with the GitlabUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GitlabTargetDetails) GetGitlabUrlOk() (*string, bool) {
	if o == nil || o.GitlabUrl == nil {
		return nil, false
	}
	return o.GitlabUrl, true
}

// HasGitlabUrl returns a boolean if a field has been set.
func (o *GitlabTargetDetails) HasGitlabUrl() bool {
	if o != nil && o.GitlabUrl != nil {
		return true
	}

	return false
}

// SetGitlabUrl gets a reference to the given string and assigns it to the GitlabUrl field.
func (o *GitlabTargetDetails) SetGitlabUrl(v string) {
	o.GitlabUrl = &v
}

func (o GitlabTargetDetails) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.GitlabAccessToken != nil {
		toSerialize["gitlab_access_token"] = o.GitlabAccessToken
	}
	if o.GitlabCertificate != nil {
		toSerialize["gitlab_certificate"] = o.GitlabCertificate
	}
	if o.GitlabUrl != nil {
		toSerialize["gitlab_url"] = o.GitlabUrl
	}
	return json.Marshal(toSerialize)
}

type NullableGitlabTargetDetails struct {
	value *GitlabTargetDetails
	isSet bool
}

func (v NullableGitlabTargetDetails) Get() *GitlabTargetDetails {
	return v.value
}

func (v *NullableGitlabTargetDetails) Set(val *GitlabTargetDetails) {
	v.value = val
	v.isSet = true
}

func (v NullableGitlabTargetDetails) IsSet() bool {
	return v.isSet
}

func (v *NullableGitlabTargetDetails) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGitlabTargetDetails(val *GitlabTargetDetails) *NullableGitlabTargetDetails {
	return &NullableGitlabTargetDetails{value: val, isSet: true}
}

func (v NullableGitlabTargetDetails) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGitlabTargetDetails) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


