/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// KerberosAuthMethodInfo struct for KerberosAuthMethodInfo
type KerberosAuthMethodInfo struct {
	KerberosKeytab *string `json:"kerberos_keytab,omitempty"`
	KerberosKrb5Conf *string `json:"kerberos_krb5_conf,omitempty"`
	LdapAnonymousSearch *bool `json:"ldap_anonymous_search,omitempty"`
	LdapBindDn *string `json:"ldap_bind_dn,omitempty"`
	LdapBindPassword *string `json:"ldap_bind_password,omitempty"`
	LdapCertificate *string `json:"ldap_certificate,omitempty"`
	LdapGroupAttr *string `json:"ldap_group_attr,omitempty"`
	LdapGroupDn *string `json:"ldap_group_dn,omitempty"`
	LdapGroupFilter *string `json:"ldap_group_filter,omitempty"`
	LdapUrlAddress *string `json:"ldap_url_address,omitempty"`
	LdapUserAttr *string `json:"ldap_user_attr,omitempty"`
	LdapUserDn *string `json:"ldap_user_dn,omitempty"`
}

// NewKerberosAuthMethodInfo instantiates a new KerberosAuthMethodInfo object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewKerberosAuthMethodInfo() *KerberosAuthMethodInfo {
	this := KerberosAuthMethodInfo{}
	return &this
}

// NewKerberosAuthMethodInfoWithDefaults instantiates a new KerberosAuthMethodInfo object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewKerberosAuthMethodInfoWithDefaults() *KerberosAuthMethodInfo {
	this := KerberosAuthMethodInfo{}
	return &this
}

// GetKerberosKeytab returns the KerberosKeytab field value if set, zero value otherwise.
func (o *KerberosAuthMethodInfo) GetKerberosKeytab() string {
	if o == nil || o.KerberosKeytab == nil {
		var ret string
		return ret
	}
	return *o.KerberosKeytab
}

// GetKerberosKeytabOk returns a tuple with the KerberosKeytab field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosAuthMethodInfo) GetKerberosKeytabOk() (*string, bool) {
	if o == nil || o.KerberosKeytab == nil {
		return nil, false
	}
	return o.KerberosKeytab, true
}

// HasKerberosKeytab returns a boolean if a field has been set.
func (o *KerberosAuthMethodInfo) HasKerberosKeytab() bool {
	if o != nil && o.KerberosKeytab != nil {
		return true
	}

	return false
}

// SetKerberosKeytab gets a reference to the given string and assigns it to the KerberosKeytab field.
func (o *KerberosAuthMethodInfo) SetKerberosKeytab(v string) {
	o.KerberosKeytab = &v
}

// GetKerberosKrb5Conf returns the KerberosKrb5Conf field value if set, zero value otherwise.
func (o *KerberosAuthMethodInfo) GetKerberosKrb5Conf() string {
	if o == nil || o.KerberosKrb5Conf == nil {
		var ret string
		return ret
	}
	return *o.KerberosKrb5Conf
}

// GetKerberosKrb5ConfOk returns a tuple with the KerberosKrb5Conf field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosAuthMethodInfo) GetKerberosKrb5ConfOk() (*string, bool) {
	if o == nil || o.KerberosKrb5Conf == nil {
		return nil, false
	}
	return o.KerberosKrb5Conf, true
}

// HasKerberosKrb5Conf returns a boolean if a field has been set.
func (o *KerberosAuthMethodInfo) HasKerberosKrb5Conf() bool {
	if o != nil && o.KerberosKrb5Conf != nil {
		return true
	}

	return false
}

// SetKerberosKrb5Conf gets a reference to the given string and assigns it to the KerberosKrb5Conf field.
func (o *KerberosAuthMethodInfo) SetKerberosKrb5Conf(v string) {
	o.KerberosKrb5Conf = &v
}

// GetLdapAnonymousSearch returns the LdapAnonymousSearch field value if set, zero value otherwise.
func (o *KerberosAuthMethodInfo) GetLdapAnonymousSearch() bool {
	if o == nil || o.LdapAnonymousSearch == nil {
		var ret bool
		return ret
	}
	return *o.LdapAnonymousSearch
}

// GetLdapAnonymousSearchOk returns a tuple with the LdapAnonymousSearch field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosAuthMethodInfo) GetLdapAnonymousSearchOk() (*bool, bool) {
	if o == nil || o.LdapAnonymousSearch == nil {
		return nil, false
	}
	return o.LdapAnonymousSearch, true
}

// HasLdapAnonymousSearch returns a boolean if a field has been set.
func (o *KerberosAuthMethodInfo) HasLdapAnonymousSearch() bool {
	if o != nil && o.LdapAnonymousSearch != nil {
		return true
	}

	return false
}

// SetLdapAnonymousSearch gets a reference to the given bool and assigns it to the LdapAnonymousSearch field.
func (o *KerberosAuthMethodInfo) SetLdapAnonymousSearch(v bool) {
	o.LdapAnonymousSearch = &v
}

// GetLdapBindDn returns the LdapBindDn field value if set, zero value otherwise.
func (o *KerberosAuthMethodInfo) GetLdapBindDn() string {
	if o == nil || o.LdapBindDn == nil {
		var ret string
		return ret
	}
	return *o.LdapBindDn
}

// GetLdapBindDnOk returns a tuple with the LdapBindDn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosAuthMethodInfo) GetLdapBindDnOk() (*string, bool) {
	if o == nil || o.LdapBindDn == nil {
		return nil, false
	}
	return o.LdapBindDn, true
}

// HasLdapBindDn returns a boolean if a field has been set.
func (o *KerberosAuthMethodInfo) HasLdapBindDn() bool {
	if o != nil && o.LdapBindDn != nil {
		return true
	}

	return false
}

// SetLdapBindDn gets a reference to the given string and assigns it to the LdapBindDn field.
func (o *KerberosAuthMethodInfo) SetLdapBindDn(v string) {
	o.LdapBindDn = &v
}

// GetLdapBindPassword returns the LdapBindPassword field value if set, zero value otherwise.
func (o *KerberosAuthMethodInfo) GetLdapBindPassword() string {
	if o == nil || o.LdapBindPassword == nil {
		var ret string
		return ret
	}
	return *o.LdapBindPassword
}

// GetLdapBindPasswordOk returns a tuple with the LdapBindPassword field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosAuthMethodInfo) GetLdapBindPasswordOk() (*string, bool) {
	if o == nil || o.LdapBindPassword == nil {
		return nil, false
	}
	return o.LdapBindPassword, true
}

// HasLdapBindPassword returns a boolean if a field has been set.
func (o *KerberosAuthMethodInfo) HasLdapBindPassword() bool {
	if o != nil && o.LdapBindPassword != nil {
		return true
	}

	return false
}

// SetLdapBindPassword gets a reference to the given string and assigns it to the LdapBindPassword field.
func (o *KerberosAuthMethodInfo) SetLdapBindPassword(v string) {
	o.LdapBindPassword = &v
}

// GetLdapCertificate returns the LdapCertificate field value if set, zero value otherwise.
func (o *KerberosAuthMethodInfo) GetLdapCertificate() string {
	if o == nil || o.LdapCertificate == nil {
		var ret string
		return ret
	}
	return *o.LdapCertificate
}

// GetLdapCertificateOk returns a tuple with the LdapCertificate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosAuthMethodInfo) GetLdapCertificateOk() (*string, bool) {
	if o == nil || o.LdapCertificate == nil {
		return nil, false
	}
	return o.LdapCertificate, true
}

// HasLdapCertificate returns a boolean if a field has been set.
func (o *KerberosAuthMethodInfo) HasLdapCertificate() bool {
	if o != nil && o.LdapCertificate != nil {
		return true
	}

	return false
}

// SetLdapCertificate gets a reference to the given string and assigns it to the LdapCertificate field.
func (o *KerberosAuthMethodInfo) SetLdapCertificate(v string) {
	o.LdapCertificate = &v
}

// GetLdapGroupAttr returns the LdapGroupAttr field value if set, zero value otherwise.
func (o *KerberosAuthMethodInfo) GetLdapGroupAttr() string {
	if o == nil || o.LdapGroupAttr == nil {
		var ret string
		return ret
	}
	return *o.LdapGroupAttr
}

// GetLdapGroupAttrOk returns a tuple with the LdapGroupAttr field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosAuthMethodInfo) GetLdapGroupAttrOk() (*string, bool) {
	if o == nil || o.LdapGroupAttr == nil {
		return nil, false
	}
	return o.LdapGroupAttr, true
}

// HasLdapGroupAttr returns a boolean if a field has been set.
func (o *KerberosAuthMethodInfo) HasLdapGroupAttr() bool {
	if o != nil && o.LdapGroupAttr != nil {
		return true
	}

	return false
}

// SetLdapGroupAttr gets a reference to the given string and assigns it to the LdapGroupAttr field.
func (o *KerberosAuthMethodInfo) SetLdapGroupAttr(v string) {
	o.LdapGroupAttr = &v
}

// GetLdapGroupDn returns the LdapGroupDn field value if set, zero value otherwise.
func (o *KerberosAuthMethodInfo) GetLdapGroupDn() string {
	if o == nil || o.LdapGroupDn == nil {
		var ret string
		return ret
	}
	return *o.LdapGroupDn
}

// GetLdapGroupDnOk returns a tuple with the LdapGroupDn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosAuthMethodInfo) GetLdapGroupDnOk() (*string, bool) {
	if o == nil || o.LdapGroupDn == nil {
		return nil, false
	}
	return o.LdapGroupDn, true
}

// HasLdapGroupDn returns a boolean if a field has been set.
func (o *KerberosAuthMethodInfo) HasLdapGroupDn() bool {
	if o != nil && o.LdapGroupDn != nil {
		return true
	}

	return false
}

// SetLdapGroupDn gets a reference to the given string and assigns it to the LdapGroupDn field.
func (o *KerberosAuthMethodInfo) SetLdapGroupDn(v string) {
	o.LdapGroupDn = &v
}

// GetLdapGroupFilter returns the LdapGroupFilter field value if set, zero value otherwise.
func (o *KerberosAuthMethodInfo) GetLdapGroupFilter() string {
	if o == nil || o.LdapGroupFilter == nil {
		var ret string
		return ret
	}
	return *o.LdapGroupFilter
}

// GetLdapGroupFilterOk returns a tuple with the LdapGroupFilter field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosAuthMethodInfo) GetLdapGroupFilterOk() (*string, bool) {
	if o == nil || o.LdapGroupFilter == nil {
		return nil, false
	}
	return o.LdapGroupFilter, true
}

// HasLdapGroupFilter returns a boolean if a field has been set.
func (o *KerberosAuthMethodInfo) HasLdapGroupFilter() bool {
	if o != nil && o.LdapGroupFilter != nil {
		return true
	}

	return false
}

// SetLdapGroupFilter gets a reference to the given string and assigns it to the LdapGroupFilter field.
func (o *KerberosAuthMethodInfo) SetLdapGroupFilter(v string) {
	o.LdapGroupFilter = &v
}

// GetLdapUrlAddress returns the LdapUrlAddress field value if set, zero value otherwise.
func (o *KerberosAuthMethodInfo) GetLdapUrlAddress() string {
	if o == nil || o.LdapUrlAddress == nil {
		var ret string
		return ret
	}
	return *o.LdapUrlAddress
}

// GetLdapUrlAddressOk returns a tuple with the LdapUrlAddress field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosAuthMethodInfo) GetLdapUrlAddressOk() (*string, bool) {
	if o == nil || o.LdapUrlAddress == nil {
		return nil, false
	}
	return o.LdapUrlAddress, true
}

// HasLdapUrlAddress returns a boolean if a field has been set.
func (o *KerberosAuthMethodInfo) HasLdapUrlAddress() bool {
	if o != nil && o.LdapUrlAddress != nil {
		return true
	}

	return false
}

// SetLdapUrlAddress gets a reference to the given string and assigns it to the LdapUrlAddress field.
func (o *KerberosAuthMethodInfo) SetLdapUrlAddress(v string) {
	o.LdapUrlAddress = &v
}

// GetLdapUserAttr returns the LdapUserAttr field value if set, zero value otherwise.
func (o *KerberosAuthMethodInfo) GetLdapUserAttr() string {
	if o == nil || o.LdapUserAttr == nil {
		var ret string
		return ret
	}
	return *o.LdapUserAttr
}

// GetLdapUserAttrOk returns a tuple with the LdapUserAttr field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosAuthMethodInfo) GetLdapUserAttrOk() (*string, bool) {
	if o == nil || o.LdapUserAttr == nil {
		return nil, false
	}
	return o.LdapUserAttr, true
}

// HasLdapUserAttr returns a boolean if a field has been set.
func (o *KerberosAuthMethodInfo) HasLdapUserAttr() bool {
	if o != nil && o.LdapUserAttr != nil {
		return true
	}

	return false
}

// SetLdapUserAttr gets a reference to the given string and assigns it to the LdapUserAttr field.
func (o *KerberosAuthMethodInfo) SetLdapUserAttr(v string) {
	o.LdapUserAttr = &v
}

// GetLdapUserDn returns the LdapUserDn field value if set, zero value otherwise.
func (o *KerberosAuthMethodInfo) GetLdapUserDn() string {
	if o == nil || o.LdapUserDn == nil {
		var ret string
		return ret
	}
	return *o.LdapUserDn
}

// GetLdapUserDnOk returns a tuple with the LdapUserDn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosAuthMethodInfo) GetLdapUserDnOk() (*string, bool) {
	if o == nil || o.LdapUserDn == nil {
		return nil, false
	}
	return o.LdapUserDn, true
}

// HasLdapUserDn returns a boolean if a field has been set.
func (o *KerberosAuthMethodInfo) HasLdapUserDn() bool {
	if o != nil && o.LdapUserDn != nil {
		return true
	}

	return false
}

// SetLdapUserDn gets a reference to the given string and assigns it to the LdapUserDn field.
func (o *KerberosAuthMethodInfo) SetLdapUserDn(v string) {
	o.LdapUserDn = &v
}

func (o KerberosAuthMethodInfo) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.KerberosKeytab != nil {
		toSerialize["kerberos_keytab"] = o.KerberosKeytab
	}
	if o.KerberosKrb5Conf != nil {
		toSerialize["kerberos_krb5_conf"] = o.KerberosKrb5Conf
	}
	if o.LdapAnonymousSearch != nil {
		toSerialize["ldap_anonymous_search"] = o.LdapAnonymousSearch
	}
	if o.LdapBindDn != nil {
		toSerialize["ldap_bind_dn"] = o.LdapBindDn
	}
	if o.LdapBindPassword != nil {
		toSerialize["ldap_bind_password"] = o.LdapBindPassword
	}
	if o.LdapCertificate != nil {
		toSerialize["ldap_certificate"] = o.LdapCertificate
	}
	if o.LdapGroupAttr != nil {
		toSerialize["ldap_group_attr"] = o.LdapGroupAttr
	}
	if o.LdapGroupDn != nil {
		toSerialize["ldap_group_dn"] = o.LdapGroupDn
	}
	if o.LdapGroupFilter != nil {
		toSerialize["ldap_group_filter"] = o.LdapGroupFilter
	}
	if o.LdapUrlAddress != nil {
		toSerialize["ldap_url_address"] = o.LdapUrlAddress
	}
	if o.LdapUserAttr != nil {
		toSerialize["ldap_user_attr"] = o.LdapUserAttr
	}
	if o.LdapUserDn != nil {
		toSerialize["ldap_user_dn"] = o.LdapUserDn
	}
	return json.Marshal(toSerialize)
}

type NullableKerberosAuthMethodInfo struct {
	value *KerberosAuthMethodInfo
	isSet bool
}

func (v NullableKerberosAuthMethodInfo) Get() *KerberosAuthMethodInfo {
	return v.value
}

func (v *NullableKerberosAuthMethodInfo) Set(val *KerberosAuthMethodInfo) {
	v.value = val
	v.isSet = true
}

func (v NullableKerberosAuthMethodInfo) IsSet() bool {
	return v.isSet
}

func (v *NullableKerberosAuthMethodInfo) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableKerberosAuthMethodInfo(val *KerberosAuthMethodInfo) *NullableKerberosAuthMethodInfo {
	return &NullableKerberosAuthMethodInfo{value: val, isSet: true}
}

func (v NullableKerberosAuthMethodInfo) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableKerberosAuthMethodInfo) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


