/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// KerberosConfigPart struct for KerberosConfigPart
type KerberosConfigPart struct {
	KerberosAccessId *string `json:"kerberos_access_id,omitempty"`
	KerberosKeytab *string `json:"kerberos_keytab,omitempty"`
	KerberosKrb5Conf *string `json:"kerberos_krb_5_conf,omitempty"`
	KerberosPrivateKey *string `json:"kerberos_private_key,omitempty"`
	LdapAnonymousSearch *bool `json:"ldap_anonymous_search,omitempty"`
	LdapBindDn *string `json:"ldap_bind_dn,omitempty"`
	LdapBindPassword *string `json:"ldap_bind_password,omitempty"`
	LdapCert *string `json:"ldap_cert,omitempty"`
	LdapGroupAttr *string `json:"ldap_group_attr,omitempty"`
	LdapGroupDn *string `json:"ldap_group_dn,omitempty"`
	LdapGroupFilter *string `json:"ldap_group_filter,omitempty"`
	LdapUrl *string `json:"ldap_url,omitempty"`
	LdapUserAttr *string `json:"ldap_user_attr,omitempty"`
	LdapUserDn *string `json:"ldap_user_dn,omitempty"`
}

// NewKerberosConfigPart instantiates a new KerberosConfigPart object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewKerberosConfigPart() *KerberosConfigPart {
	this := KerberosConfigPart{}
	return &this
}

// NewKerberosConfigPartWithDefaults instantiates a new KerberosConfigPart object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewKerberosConfigPartWithDefaults() *KerberosConfigPart {
	this := KerberosConfigPart{}
	return &this
}

// GetKerberosAccessId returns the KerberosAccessId field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetKerberosAccessId() string {
	if o == nil || o.KerberosAccessId == nil {
		var ret string
		return ret
	}
	return *o.KerberosAccessId
}

// GetKerberosAccessIdOk returns a tuple with the KerberosAccessId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetKerberosAccessIdOk() (*string, bool) {
	if o == nil || o.KerberosAccessId == nil {
		return nil, false
	}
	return o.KerberosAccessId, true
}

// HasKerberosAccessId returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasKerberosAccessId() bool {
	if o != nil && o.KerberosAccessId != nil {
		return true
	}

	return false
}

// SetKerberosAccessId gets a reference to the given string and assigns it to the KerberosAccessId field.
func (o *KerberosConfigPart) SetKerberosAccessId(v string) {
	o.KerberosAccessId = &v
}

// GetKerberosKeytab returns the KerberosKeytab field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetKerberosKeytab() string {
	if o == nil || o.KerberosKeytab == nil {
		var ret string
		return ret
	}
	return *o.KerberosKeytab
}

// GetKerberosKeytabOk returns a tuple with the KerberosKeytab field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetKerberosKeytabOk() (*string, bool) {
	if o == nil || o.KerberosKeytab == nil {
		return nil, false
	}
	return o.KerberosKeytab, true
}

// HasKerberosKeytab returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasKerberosKeytab() bool {
	if o != nil && o.KerberosKeytab != nil {
		return true
	}

	return false
}

// SetKerberosKeytab gets a reference to the given string and assigns it to the KerberosKeytab field.
func (o *KerberosConfigPart) SetKerberosKeytab(v string) {
	o.KerberosKeytab = &v
}

// GetKerberosKrb5Conf returns the KerberosKrb5Conf field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetKerberosKrb5Conf() string {
	if o == nil || o.KerberosKrb5Conf == nil {
		var ret string
		return ret
	}
	return *o.KerberosKrb5Conf
}

// GetKerberosKrb5ConfOk returns a tuple with the KerberosKrb5Conf field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetKerberosKrb5ConfOk() (*string, bool) {
	if o == nil || o.KerberosKrb5Conf == nil {
		return nil, false
	}
	return o.KerberosKrb5Conf, true
}

// HasKerberosKrb5Conf returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasKerberosKrb5Conf() bool {
	if o != nil && o.KerberosKrb5Conf != nil {
		return true
	}

	return false
}

// SetKerberosKrb5Conf gets a reference to the given string and assigns it to the KerberosKrb5Conf field.
func (o *KerberosConfigPart) SetKerberosKrb5Conf(v string) {
	o.KerberosKrb5Conf = &v
}

// GetKerberosPrivateKey returns the KerberosPrivateKey field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetKerberosPrivateKey() string {
	if o == nil || o.KerberosPrivateKey == nil {
		var ret string
		return ret
	}
	return *o.KerberosPrivateKey
}

// GetKerberosPrivateKeyOk returns a tuple with the KerberosPrivateKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetKerberosPrivateKeyOk() (*string, bool) {
	if o == nil || o.KerberosPrivateKey == nil {
		return nil, false
	}
	return o.KerberosPrivateKey, true
}

// HasKerberosPrivateKey returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasKerberosPrivateKey() bool {
	if o != nil && o.KerberosPrivateKey != nil {
		return true
	}

	return false
}

// SetKerberosPrivateKey gets a reference to the given string and assigns it to the KerberosPrivateKey field.
func (o *KerberosConfigPart) SetKerberosPrivateKey(v string) {
	o.KerberosPrivateKey = &v
}

// GetLdapAnonymousSearch returns the LdapAnonymousSearch field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetLdapAnonymousSearch() bool {
	if o == nil || o.LdapAnonymousSearch == nil {
		var ret bool
		return ret
	}
	return *o.LdapAnonymousSearch
}

// GetLdapAnonymousSearchOk returns a tuple with the LdapAnonymousSearch field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetLdapAnonymousSearchOk() (*bool, bool) {
	if o == nil || o.LdapAnonymousSearch == nil {
		return nil, false
	}
	return o.LdapAnonymousSearch, true
}

// HasLdapAnonymousSearch returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasLdapAnonymousSearch() bool {
	if o != nil && o.LdapAnonymousSearch != nil {
		return true
	}

	return false
}

// SetLdapAnonymousSearch gets a reference to the given bool and assigns it to the LdapAnonymousSearch field.
func (o *KerberosConfigPart) SetLdapAnonymousSearch(v bool) {
	o.LdapAnonymousSearch = &v
}

// GetLdapBindDn returns the LdapBindDn field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetLdapBindDn() string {
	if o == nil || o.LdapBindDn == nil {
		var ret string
		return ret
	}
	return *o.LdapBindDn
}

// GetLdapBindDnOk returns a tuple with the LdapBindDn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetLdapBindDnOk() (*string, bool) {
	if o == nil || o.LdapBindDn == nil {
		return nil, false
	}
	return o.LdapBindDn, true
}

// HasLdapBindDn returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasLdapBindDn() bool {
	if o != nil && o.LdapBindDn != nil {
		return true
	}

	return false
}

// SetLdapBindDn gets a reference to the given string and assigns it to the LdapBindDn field.
func (o *KerberosConfigPart) SetLdapBindDn(v string) {
	o.LdapBindDn = &v
}

// GetLdapBindPassword returns the LdapBindPassword field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetLdapBindPassword() string {
	if o == nil || o.LdapBindPassword == nil {
		var ret string
		return ret
	}
	return *o.LdapBindPassword
}

// GetLdapBindPasswordOk returns a tuple with the LdapBindPassword field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetLdapBindPasswordOk() (*string, bool) {
	if o == nil || o.LdapBindPassword == nil {
		return nil, false
	}
	return o.LdapBindPassword, true
}

// HasLdapBindPassword returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasLdapBindPassword() bool {
	if o != nil && o.LdapBindPassword != nil {
		return true
	}

	return false
}

// SetLdapBindPassword gets a reference to the given string and assigns it to the LdapBindPassword field.
func (o *KerberosConfigPart) SetLdapBindPassword(v string) {
	o.LdapBindPassword = &v
}

// GetLdapCert returns the LdapCert field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetLdapCert() string {
	if o == nil || o.LdapCert == nil {
		var ret string
		return ret
	}
	return *o.LdapCert
}

// GetLdapCertOk returns a tuple with the LdapCert field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetLdapCertOk() (*string, bool) {
	if o == nil || o.LdapCert == nil {
		return nil, false
	}
	return o.LdapCert, true
}

// HasLdapCert returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasLdapCert() bool {
	if o != nil && o.LdapCert != nil {
		return true
	}

	return false
}

// SetLdapCert gets a reference to the given string and assigns it to the LdapCert field.
func (o *KerberosConfigPart) SetLdapCert(v string) {
	o.LdapCert = &v
}

// GetLdapGroupAttr returns the LdapGroupAttr field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetLdapGroupAttr() string {
	if o == nil || o.LdapGroupAttr == nil {
		var ret string
		return ret
	}
	return *o.LdapGroupAttr
}

// GetLdapGroupAttrOk returns a tuple with the LdapGroupAttr field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetLdapGroupAttrOk() (*string, bool) {
	if o == nil || o.LdapGroupAttr == nil {
		return nil, false
	}
	return o.LdapGroupAttr, true
}

// HasLdapGroupAttr returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasLdapGroupAttr() bool {
	if o != nil && o.LdapGroupAttr != nil {
		return true
	}

	return false
}

// SetLdapGroupAttr gets a reference to the given string and assigns it to the LdapGroupAttr field.
func (o *KerberosConfigPart) SetLdapGroupAttr(v string) {
	o.LdapGroupAttr = &v
}

// GetLdapGroupDn returns the LdapGroupDn field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetLdapGroupDn() string {
	if o == nil || o.LdapGroupDn == nil {
		var ret string
		return ret
	}
	return *o.LdapGroupDn
}

// GetLdapGroupDnOk returns a tuple with the LdapGroupDn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetLdapGroupDnOk() (*string, bool) {
	if o == nil || o.LdapGroupDn == nil {
		return nil, false
	}
	return o.LdapGroupDn, true
}

// HasLdapGroupDn returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasLdapGroupDn() bool {
	if o != nil && o.LdapGroupDn != nil {
		return true
	}

	return false
}

// SetLdapGroupDn gets a reference to the given string and assigns it to the LdapGroupDn field.
func (o *KerberosConfigPart) SetLdapGroupDn(v string) {
	o.LdapGroupDn = &v
}

// GetLdapGroupFilter returns the LdapGroupFilter field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetLdapGroupFilter() string {
	if o == nil || o.LdapGroupFilter == nil {
		var ret string
		return ret
	}
	return *o.LdapGroupFilter
}

// GetLdapGroupFilterOk returns a tuple with the LdapGroupFilter field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetLdapGroupFilterOk() (*string, bool) {
	if o == nil || o.LdapGroupFilter == nil {
		return nil, false
	}
	return o.LdapGroupFilter, true
}

// HasLdapGroupFilter returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasLdapGroupFilter() bool {
	if o != nil && o.LdapGroupFilter != nil {
		return true
	}

	return false
}

// SetLdapGroupFilter gets a reference to the given string and assigns it to the LdapGroupFilter field.
func (o *KerberosConfigPart) SetLdapGroupFilter(v string) {
	o.LdapGroupFilter = &v
}

// GetLdapUrl returns the LdapUrl field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetLdapUrl() string {
	if o == nil || o.LdapUrl == nil {
		var ret string
		return ret
	}
	return *o.LdapUrl
}

// GetLdapUrlOk returns a tuple with the LdapUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetLdapUrlOk() (*string, bool) {
	if o == nil || o.LdapUrl == nil {
		return nil, false
	}
	return o.LdapUrl, true
}

// HasLdapUrl returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasLdapUrl() bool {
	if o != nil && o.LdapUrl != nil {
		return true
	}

	return false
}

// SetLdapUrl gets a reference to the given string and assigns it to the LdapUrl field.
func (o *KerberosConfigPart) SetLdapUrl(v string) {
	o.LdapUrl = &v
}

// GetLdapUserAttr returns the LdapUserAttr field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetLdapUserAttr() string {
	if o == nil || o.LdapUserAttr == nil {
		var ret string
		return ret
	}
	return *o.LdapUserAttr
}

// GetLdapUserAttrOk returns a tuple with the LdapUserAttr field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetLdapUserAttrOk() (*string, bool) {
	if o == nil || o.LdapUserAttr == nil {
		return nil, false
	}
	return o.LdapUserAttr, true
}

// HasLdapUserAttr returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasLdapUserAttr() bool {
	if o != nil && o.LdapUserAttr != nil {
		return true
	}

	return false
}

// SetLdapUserAttr gets a reference to the given string and assigns it to the LdapUserAttr field.
func (o *KerberosConfigPart) SetLdapUserAttr(v string) {
	o.LdapUserAttr = &v
}

// GetLdapUserDn returns the LdapUserDn field value if set, zero value otherwise.
func (o *KerberosConfigPart) GetLdapUserDn() string {
	if o == nil || o.LdapUserDn == nil {
		var ret string
		return ret
	}
	return *o.LdapUserDn
}

// GetLdapUserDnOk returns a tuple with the LdapUserDn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KerberosConfigPart) GetLdapUserDnOk() (*string, bool) {
	if o == nil || o.LdapUserDn == nil {
		return nil, false
	}
	return o.LdapUserDn, true
}

// HasLdapUserDn returns a boolean if a field has been set.
func (o *KerberosConfigPart) HasLdapUserDn() bool {
	if o != nil && o.LdapUserDn != nil {
		return true
	}

	return false
}

// SetLdapUserDn gets a reference to the given string and assigns it to the LdapUserDn field.
func (o *KerberosConfigPart) SetLdapUserDn(v string) {
	o.LdapUserDn = &v
}

func (o KerberosConfigPart) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.KerberosAccessId != nil {
		toSerialize["kerberos_access_id"] = o.KerberosAccessId
	}
	if o.KerberosKeytab != nil {
		toSerialize["kerberos_keytab"] = o.KerberosKeytab
	}
	if o.KerberosKrb5Conf != nil {
		toSerialize["kerberos_krb_5_conf"] = o.KerberosKrb5Conf
	}
	if o.KerberosPrivateKey != nil {
		toSerialize["kerberos_private_key"] = o.KerberosPrivateKey
	}
	if o.LdapAnonymousSearch != nil {
		toSerialize["ldap_anonymous_search"] = o.LdapAnonymousSearch
	}
	if o.LdapBindDn != nil {
		toSerialize["ldap_bind_dn"] = o.LdapBindDn
	}
	if o.LdapBindPassword != nil {
		toSerialize["ldap_bind_password"] = o.LdapBindPassword
	}
	if o.LdapCert != nil {
		toSerialize["ldap_cert"] = o.LdapCert
	}
	if o.LdapGroupAttr != nil {
		toSerialize["ldap_group_attr"] = o.LdapGroupAttr
	}
	if o.LdapGroupDn != nil {
		toSerialize["ldap_group_dn"] = o.LdapGroupDn
	}
	if o.LdapGroupFilter != nil {
		toSerialize["ldap_group_filter"] = o.LdapGroupFilter
	}
	if o.LdapUrl != nil {
		toSerialize["ldap_url"] = o.LdapUrl
	}
	if o.LdapUserAttr != nil {
		toSerialize["ldap_user_attr"] = o.LdapUserAttr
	}
	if o.LdapUserDn != nil {
		toSerialize["ldap_user_dn"] = o.LdapUserDn
	}
	return json.Marshal(toSerialize)
}

type NullableKerberosConfigPart struct {
	value *KerberosConfigPart
	isSet bool
}

func (v NullableKerberosConfigPart) Get() *KerberosConfigPart {
	return v.value
}

func (v *NullableKerberosConfigPart) Set(val *KerberosConfigPart) {
	v.value = val
	v.isSet = true
}

func (v NullableKerberosConfigPart) IsSet() bool {
	return v.isSet
}

func (v *NullableKerberosConfigPart) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableKerberosConfigPart(val *KerberosConfigPart) *NullableKerberosConfigPart {
	return &NullableKerberosConfigPart{value: val, isSet: true}
}

func (v NullableKerberosConfigPart) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableKerberosConfigPart) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


