/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// KubeconfigExec struct for KubeconfigExec
type KubeconfigExec struct {
	ApiVersion *string `json:"apiVersion,omitempty"`
	Args *[]string `json:"args,omitempty"`
	Command *string `json:"command,omitempty"`
	InteractiveMode *string `json:"interactiveMode,omitempty"`
}

// NewKubeconfigExec instantiates a new KubeconfigExec object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewKubeconfigExec() *KubeconfigExec {
	this := KubeconfigExec{}
	return &this
}

// NewKubeconfigExecWithDefaults instantiates a new KubeconfigExec object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewKubeconfigExecWithDefaults() *KubeconfigExec {
	this := KubeconfigExec{}
	return &this
}

// GetApiVersion returns the ApiVersion field value if set, zero value otherwise.
func (o *KubeconfigExec) GetApiVersion() string {
	if o == nil || o.ApiVersion == nil {
		var ret string
		return ret
	}
	return *o.ApiVersion
}

// GetApiVersionOk returns a tuple with the ApiVersion field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KubeconfigExec) GetApiVersionOk() (*string, bool) {
	if o == nil || o.ApiVersion == nil {
		return nil, false
	}
	return o.ApiVersion, true
}

// HasApiVersion returns a boolean if a field has been set.
func (o *KubeconfigExec) HasApiVersion() bool {
	if o != nil && o.ApiVersion != nil {
		return true
	}

	return false
}

// SetApiVersion gets a reference to the given string and assigns it to the ApiVersion field.
func (o *KubeconfigExec) SetApiVersion(v string) {
	o.ApiVersion = &v
}

// GetArgs returns the Args field value if set, zero value otherwise.
func (o *KubeconfigExec) GetArgs() []string {
	if o == nil || o.Args == nil {
		var ret []string
		return ret
	}
	return *o.Args
}

// GetArgsOk returns a tuple with the Args field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KubeconfigExec) GetArgsOk() (*[]string, bool) {
	if o == nil || o.Args == nil {
		return nil, false
	}
	return o.Args, true
}

// HasArgs returns a boolean if a field has been set.
func (o *KubeconfigExec) HasArgs() bool {
	if o != nil && o.Args != nil {
		return true
	}

	return false
}

// SetArgs gets a reference to the given []string and assigns it to the Args field.
func (o *KubeconfigExec) SetArgs(v []string) {
	o.Args = &v
}

// GetCommand returns the Command field value if set, zero value otherwise.
func (o *KubeconfigExec) GetCommand() string {
	if o == nil || o.Command == nil {
		var ret string
		return ret
	}
	return *o.Command
}

// GetCommandOk returns a tuple with the Command field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KubeconfigExec) GetCommandOk() (*string, bool) {
	if o == nil || o.Command == nil {
		return nil, false
	}
	return o.Command, true
}

// HasCommand returns a boolean if a field has been set.
func (o *KubeconfigExec) HasCommand() bool {
	if o != nil && o.Command != nil {
		return true
	}

	return false
}

// SetCommand gets a reference to the given string and assigns it to the Command field.
func (o *KubeconfigExec) SetCommand(v string) {
	o.Command = &v
}

// GetInteractiveMode returns the InteractiveMode field value if set, zero value otherwise.
func (o *KubeconfigExec) GetInteractiveMode() string {
	if o == nil || o.InteractiveMode == nil {
		var ret string
		return ret
	}
	return *o.InteractiveMode
}

// GetInteractiveModeOk returns a tuple with the InteractiveMode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KubeconfigExec) GetInteractiveModeOk() (*string, bool) {
	if o == nil || o.InteractiveMode == nil {
		return nil, false
	}
	return o.InteractiveMode, true
}

// HasInteractiveMode returns a boolean if a field has been set.
func (o *KubeconfigExec) HasInteractiveMode() bool {
	if o != nil && o.InteractiveMode != nil {
		return true
	}

	return false
}

// SetInteractiveMode gets a reference to the given string and assigns it to the InteractiveMode field.
func (o *KubeconfigExec) SetInteractiveMode(v string) {
	o.InteractiveMode = &v
}

func (o KubeconfigExec) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.ApiVersion != nil {
		toSerialize["apiVersion"] = o.ApiVersion
	}
	if o.Args != nil {
		toSerialize["args"] = o.Args
	}
	if o.Command != nil {
		toSerialize["command"] = o.Command
	}
	if o.InteractiveMode != nil {
		toSerialize["interactiveMode"] = o.InteractiveMode
	}
	return json.Marshal(toSerialize)
}

type NullableKubeconfigExec struct {
	value *KubeconfigExec
	isSet bool
}

func (v NullableKubeconfigExec) Get() *KubeconfigExec {
	return v.value
}

func (v *NullableKubeconfigExec) Set(val *KubeconfigExec) {
	v.value = val
	v.isSet = true
}

func (v NullableKubeconfigExec) IsSet() bool {
	return v.isSet
}

func (v *NullableKubeconfigExec) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableKubeconfigExec(val *KubeconfigExec) *NullableKubeconfigExec {
	return &NullableKubeconfigExec{value: val, isSet: true}
}

func (v NullableKubeconfigExec) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableKubeconfigExec) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


