/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// KubeconfigGenerateOutput struct for KubeconfigGenerateOutput
type KubeconfigGenerateOutput struct {
	ConflictedClustersNames *[]string `json:"conflicted_clusters_names,omitempty"`
	Data *KubeConfigValue `json:"data,omitempty"`
	Errors *[]string `json:"errors,omitempty"`
}

// NewKubeconfigGenerateOutput instantiates a new KubeconfigGenerateOutput object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewKubeconfigGenerateOutput() *KubeconfigGenerateOutput {
	this := KubeconfigGenerateOutput{}
	return &this
}

// NewKubeconfigGenerateOutputWithDefaults instantiates a new KubeconfigGenerateOutput object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewKubeconfigGenerateOutputWithDefaults() *KubeconfigGenerateOutput {
	this := KubeconfigGenerateOutput{}
	return &this
}

// GetConflictedClustersNames returns the ConflictedClustersNames field value if set, zero value otherwise.
func (o *KubeconfigGenerateOutput) GetConflictedClustersNames() []string {
	if o == nil || o.ConflictedClustersNames == nil {
		var ret []string
		return ret
	}
	return *o.ConflictedClustersNames
}

// GetConflictedClustersNamesOk returns a tuple with the ConflictedClustersNames field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KubeconfigGenerateOutput) GetConflictedClustersNamesOk() (*[]string, bool) {
	if o == nil || o.ConflictedClustersNames == nil {
		return nil, false
	}
	return o.ConflictedClustersNames, true
}

// HasConflictedClustersNames returns a boolean if a field has been set.
func (o *KubeconfigGenerateOutput) HasConflictedClustersNames() bool {
	if o != nil && o.ConflictedClustersNames != nil {
		return true
	}

	return false
}

// SetConflictedClustersNames gets a reference to the given []string and assigns it to the ConflictedClustersNames field.
func (o *KubeconfigGenerateOutput) SetConflictedClustersNames(v []string) {
	o.ConflictedClustersNames = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *KubeconfigGenerateOutput) GetData() KubeConfigValue {
	if o == nil || o.Data == nil {
		var ret KubeConfigValue
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KubeconfigGenerateOutput) GetDataOk() (*KubeConfigValue, bool) {
	if o == nil || o.Data == nil {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *KubeconfigGenerateOutput) HasData() bool {
	if o != nil && o.Data != nil {
		return true
	}

	return false
}

// SetData gets a reference to the given KubeConfigValue and assigns it to the Data field.
func (o *KubeconfigGenerateOutput) SetData(v KubeConfigValue) {
	o.Data = &v
}

// GetErrors returns the Errors field value if set, zero value otherwise.
func (o *KubeconfigGenerateOutput) GetErrors() []string {
	if o == nil || o.Errors == nil {
		var ret []string
		return ret
	}
	return *o.Errors
}

// GetErrorsOk returns a tuple with the Errors field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KubeconfigGenerateOutput) GetErrorsOk() (*[]string, bool) {
	if o == nil || o.Errors == nil {
		return nil, false
	}
	return o.Errors, true
}

// HasErrors returns a boolean if a field has been set.
func (o *KubeconfigGenerateOutput) HasErrors() bool {
	if o != nil && o.Errors != nil {
		return true
	}

	return false
}

// SetErrors gets a reference to the given []string and assigns it to the Errors field.
func (o *KubeconfigGenerateOutput) SetErrors(v []string) {
	o.Errors = &v
}

func (o KubeconfigGenerateOutput) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.ConflictedClustersNames != nil {
		toSerialize["conflicted_clusters_names"] = o.ConflictedClustersNames
	}
	if o.Data != nil {
		toSerialize["data"] = o.Data
	}
	if o.Errors != nil {
		toSerialize["errors"] = o.Errors
	}
	return json.Marshal(toSerialize)
}

type NullableKubeconfigGenerateOutput struct {
	value *KubeconfigGenerateOutput
	isSet bool
}

func (v NullableKubeconfigGenerateOutput) Get() *KubeconfigGenerateOutput {
	return v.value
}

func (v *NullableKubeconfigGenerateOutput) Set(val *KubeconfigGenerateOutput) {
	v.value = val
	v.isSet = true
}

func (v NullableKubeconfigGenerateOutput) IsSet() bool {
	return v.isSet
}

func (v *NullableKubeconfigGenerateOutput) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableKubeconfigGenerateOutput(val *KubeconfigGenerateOutput) *NullableKubeconfigGenerateOutput {
	return &NullableKubeconfigGenerateOutput{value: val, isSet: true}
}

func (v NullableKubeconfigGenerateOutput) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableKubeconfigGenerateOutput) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


