/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// ListSraSessionsOutput struct for ListSraSessionsOutput
type ListSraSessionsOutput struct {
	AllowedGateways *[]string `json:"allowed_gateways,omitempty"`
	NextPage *string `json:"next_page,omitempty"`
	Sessions *[]SraSessionEntryOut `json:"sessions,omitempty"`
}

// NewListSraSessionsOutput instantiates a new ListSraSessionsOutput object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListSraSessionsOutput() *ListSraSessionsOutput {
	this := ListSraSessionsOutput{}
	return &this
}

// NewListSraSessionsOutputWithDefaults instantiates a new ListSraSessionsOutput object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListSraSessionsOutputWithDefaults() *ListSraSessionsOutput {
	this := ListSraSessionsOutput{}
	return &this
}

// GetAllowedGateways returns the AllowedGateways field value if set, zero value otherwise.
func (o *ListSraSessionsOutput) GetAllowedGateways() []string {
	if o == nil || o.AllowedGateways == nil {
		var ret []string
		return ret
	}
	return *o.AllowedGateways
}

// GetAllowedGatewaysOk returns a tuple with the AllowedGateways field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListSraSessionsOutput) GetAllowedGatewaysOk() (*[]string, bool) {
	if o == nil || o.AllowedGateways == nil {
		return nil, false
	}
	return o.AllowedGateways, true
}

// HasAllowedGateways returns a boolean if a field has been set.
func (o *ListSraSessionsOutput) HasAllowedGateways() bool {
	if o != nil && o.AllowedGateways != nil {
		return true
	}

	return false
}

// SetAllowedGateways gets a reference to the given []string and assigns it to the AllowedGateways field.
func (o *ListSraSessionsOutput) SetAllowedGateways(v []string) {
	o.AllowedGateways = &v
}

// GetNextPage returns the NextPage field value if set, zero value otherwise.
func (o *ListSraSessionsOutput) GetNextPage() string {
	if o == nil || o.NextPage == nil {
		var ret string
		return ret
	}
	return *o.NextPage
}

// GetNextPageOk returns a tuple with the NextPage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListSraSessionsOutput) GetNextPageOk() (*string, bool) {
	if o == nil || o.NextPage == nil {
		return nil, false
	}
	return o.NextPage, true
}

// HasNextPage returns a boolean if a field has been set.
func (o *ListSraSessionsOutput) HasNextPage() bool {
	if o != nil && o.NextPage != nil {
		return true
	}

	return false
}

// SetNextPage gets a reference to the given string and assigns it to the NextPage field.
func (o *ListSraSessionsOutput) SetNextPage(v string) {
	o.NextPage = &v
}

// GetSessions returns the Sessions field value if set, zero value otherwise.
func (o *ListSraSessionsOutput) GetSessions() []SraSessionEntryOut {
	if o == nil || o.Sessions == nil {
		var ret []SraSessionEntryOut
		return ret
	}
	return *o.Sessions
}

// GetSessionsOk returns a tuple with the Sessions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListSraSessionsOutput) GetSessionsOk() (*[]SraSessionEntryOut, bool) {
	if o == nil || o.Sessions == nil {
		return nil, false
	}
	return o.Sessions, true
}

// HasSessions returns a boolean if a field has been set.
func (o *ListSraSessionsOutput) HasSessions() bool {
	if o != nil && o.Sessions != nil {
		return true
	}

	return false
}

// SetSessions gets a reference to the given []SraSessionEntryOut and assigns it to the Sessions field.
func (o *ListSraSessionsOutput) SetSessions(v []SraSessionEntryOut) {
	o.Sessions = &v
}

func (o ListSraSessionsOutput) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.AllowedGateways != nil {
		toSerialize["allowed_gateways"] = o.AllowedGateways
	}
	if o.NextPage != nil {
		toSerialize["next_page"] = o.NextPage
	}
	if o.Sessions != nil {
		toSerialize["sessions"] = o.Sessions
	}
	return json.Marshal(toSerialize)
}

type NullableListSraSessionsOutput struct {
	value *ListSraSessionsOutput
	isSet bool
}

func (v NullableListSraSessionsOutput) Get() *ListSraSessionsOutput {
	return v.value
}

func (v *NullableListSraSessionsOutput) Set(val *ListSraSessionsOutput) {
	v.value = val
	v.isSet = true
}

func (v NullableListSraSessionsOutput) IsSet() bool {
	return v.isSet
}

func (v *NullableListSraSessionsOutput) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListSraSessionsOutput(val *ListSraSessionsOutput) *NullableListSraSessionsOutput {
	return &NullableListSraSessionsOutput{value: val, isSet: true}
}

func (v NullableListSraSessionsOutput) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListSraSessionsOutput) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


