/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// PasswordExpirationInfo struct for PasswordExpirationInfo
type PasswordExpirationInfo struct {
	DaysBeforeExpire *int64 `json:"days_before_expire,omitempty"`
	DaysBeforeNotification *int64 `json:"days_before_notification,omitempty"`
	// r/o calculated parameter
	DaysUntilExpire *int64 `json:"days_until_expire,omitempty"`
	Enable *bool `json:"enable,omitempty"`
}

// NewPasswordExpirationInfo instantiates a new PasswordExpirationInfo object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPasswordExpirationInfo() *PasswordExpirationInfo {
	this := PasswordExpirationInfo{}
	return &this
}

// NewPasswordExpirationInfoWithDefaults instantiates a new PasswordExpirationInfo object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPasswordExpirationInfoWithDefaults() *PasswordExpirationInfo {
	this := PasswordExpirationInfo{}
	return &this
}

// GetDaysBeforeExpire returns the DaysBeforeExpire field value if set, zero value otherwise.
func (o *PasswordExpirationInfo) GetDaysBeforeExpire() int64 {
	if o == nil || o.DaysBeforeExpire == nil {
		var ret int64
		return ret
	}
	return *o.DaysBeforeExpire
}

// GetDaysBeforeExpireOk returns a tuple with the DaysBeforeExpire field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PasswordExpirationInfo) GetDaysBeforeExpireOk() (*int64, bool) {
	if o == nil || o.DaysBeforeExpire == nil {
		return nil, false
	}
	return o.DaysBeforeExpire, true
}

// HasDaysBeforeExpire returns a boolean if a field has been set.
func (o *PasswordExpirationInfo) HasDaysBeforeExpire() bool {
	if o != nil && o.DaysBeforeExpire != nil {
		return true
	}

	return false
}

// SetDaysBeforeExpire gets a reference to the given int64 and assigns it to the DaysBeforeExpire field.
func (o *PasswordExpirationInfo) SetDaysBeforeExpire(v int64) {
	o.DaysBeforeExpire = &v
}

// GetDaysBeforeNotification returns the DaysBeforeNotification field value if set, zero value otherwise.
func (o *PasswordExpirationInfo) GetDaysBeforeNotification() int64 {
	if o == nil || o.DaysBeforeNotification == nil {
		var ret int64
		return ret
	}
	return *o.DaysBeforeNotification
}

// GetDaysBeforeNotificationOk returns a tuple with the DaysBeforeNotification field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PasswordExpirationInfo) GetDaysBeforeNotificationOk() (*int64, bool) {
	if o == nil || o.DaysBeforeNotification == nil {
		return nil, false
	}
	return o.DaysBeforeNotification, true
}

// HasDaysBeforeNotification returns a boolean if a field has been set.
func (o *PasswordExpirationInfo) HasDaysBeforeNotification() bool {
	if o != nil && o.DaysBeforeNotification != nil {
		return true
	}

	return false
}

// SetDaysBeforeNotification gets a reference to the given int64 and assigns it to the DaysBeforeNotification field.
func (o *PasswordExpirationInfo) SetDaysBeforeNotification(v int64) {
	o.DaysBeforeNotification = &v
}

// GetDaysUntilExpire returns the DaysUntilExpire field value if set, zero value otherwise.
func (o *PasswordExpirationInfo) GetDaysUntilExpire() int64 {
	if o == nil || o.DaysUntilExpire == nil {
		var ret int64
		return ret
	}
	return *o.DaysUntilExpire
}

// GetDaysUntilExpireOk returns a tuple with the DaysUntilExpire field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PasswordExpirationInfo) GetDaysUntilExpireOk() (*int64, bool) {
	if o == nil || o.DaysUntilExpire == nil {
		return nil, false
	}
	return o.DaysUntilExpire, true
}

// HasDaysUntilExpire returns a boolean if a field has been set.
func (o *PasswordExpirationInfo) HasDaysUntilExpire() bool {
	if o != nil && o.DaysUntilExpire != nil {
		return true
	}

	return false
}

// SetDaysUntilExpire gets a reference to the given int64 and assigns it to the DaysUntilExpire field.
func (o *PasswordExpirationInfo) SetDaysUntilExpire(v int64) {
	o.DaysUntilExpire = &v
}

// GetEnable returns the Enable field value if set, zero value otherwise.
func (o *PasswordExpirationInfo) GetEnable() bool {
	if o == nil || o.Enable == nil {
		var ret bool
		return ret
	}
	return *o.Enable
}

// GetEnableOk returns a tuple with the Enable field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PasswordExpirationInfo) GetEnableOk() (*bool, bool) {
	if o == nil || o.Enable == nil {
		return nil, false
	}
	return o.Enable, true
}

// HasEnable returns a boolean if a field has been set.
func (o *PasswordExpirationInfo) HasEnable() bool {
	if o != nil && o.Enable != nil {
		return true
	}

	return false
}

// SetEnable gets a reference to the given bool and assigns it to the Enable field.
func (o *PasswordExpirationInfo) SetEnable(v bool) {
	o.Enable = &v
}

func (o PasswordExpirationInfo) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.DaysBeforeExpire != nil {
		toSerialize["days_before_expire"] = o.DaysBeforeExpire
	}
	if o.DaysBeforeNotification != nil {
		toSerialize["days_before_notification"] = o.DaysBeforeNotification
	}
	if o.DaysUntilExpire != nil {
		toSerialize["days_until_expire"] = o.DaysUntilExpire
	}
	if o.Enable != nil {
		toSerialize["enable"] = o.Enable
	}
	return json.Marshal(toSerialize)
}

type NullablePasswordExpirationInfo struct {
	value *PasswordExpirationInfo
	isSet bool
}

func (v NullablePasswordExpirationInfo) Get() *PasswordExpirationInfo {
	return v.value
}

func (v *NullablePasswordExpirationInfo) Set(val *PasswordExpirationInfo) {
	v.value = val
	v.isSet = true
}

func (v NullablePasswordExpirationInfo) IsSet() bool {
	return v.isSet
}

func (v *NullablePasswordExpirationInfo) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePasswordExpirationInfo(val *PasswordExpirationInfo) *NullablePasswordExpirationInfo {
	return &NullablePasswordExpirationInfo{value: val, isSet: true}
}

func (v NullablePasswordExpirationInfo) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePasswordExpirationInfo) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


