/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// SshBastionConf struct for SshBastionConf
type SshBastionConf struct {
	HideSessionRecording *bool `json:"hide_session_recording,omitempty"`
	Kexalgs *string `json:"kexalgs,omitempty"`
	LogForwarding *LogForwardingConfigPart `json:"log_forwarding,omitempty"`
	SessionTermination *SshBastionSessionTermination `json:"session_termination,omitempty"`
}

// NewSshBastionConf instantiates a new SshBastionConf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSshBastionConf() *SshBastionConf {
	this := SshBastionConf{}
	return &this
}

// NewSshBastionConfWithDefaults instantiates a new SshBastionConf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSshBastionConfWithDefaults() *SshBastionConf {
	this := SshBastionConf{}
	return &this
}

// GetHideSessionRecording returns the HideSessionRecording field value if set, zero value otherwise.
func (o *SshBastionConf) GetHideSessionRecording() bool {
	if o == nil || o.HideSessionRecording == nil {
		var ret bool
		return ret
	}
	return *o.HideSessionRecording
}

// GetHideSessionRecordingOk returns a tuple with the HideSessionRecording field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SshBastionConf) GetHideSessionRecordingOk() (*bool, bool) {
	if o == nil || o.HideSessionRecording == nil {
		return nil, false
	}
	return o.HideSessionRecording, true
}

// HasHideSessionRecording returns a boolean if a field has been set.
func (o *SshBastionConf) HasHideSessionRecording() bool {
	if o != nil && o.HideSessionRecording != nil {
		return true
	}

	return false
}

// SetHideSessionRecording gets a reference to the given bool and assigns it to the HideSessionRecording field.
func (o *SshBastionConf) SetHideSessionRecording(v bool) {
	o.HideSessionRecording = &v
}

// GetKexalgs returns the Kexalgs field value if set, zero value otherwise.
func (o *SshBastionConf) GetKexalgs() string {
	if o == nil || o.Kexalgs == nil {
		var ret string
		return ret
	}
	return *o.Kexalgs
}

// GetKexalgsOk returns a tuple with the Kexalgs field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SshBastionConf) GetKexalgsOk() (*string, bool) {
	if o == nil || o.Kexalgs == nil {
		return nil, false
	}
	return o.Kexalgs, true
}

// HasKexalgs returns a boolean if a field has been set.
func (o *SshBastionConf) HasKexalgs() bool {
	if o != nil && o.Kexalgs != nil {
		return true
	}

	return false
}

// SetKexalgs gets a reference to the given string and assigns it to the Kexalgs field.
func (o *SshBastionConf) SetKexalgs(v string) {
	o.Kexalgs = &v
}

// GetLogForwarding returns the LogForwarding field value if set, zero value otherwise.
func (o *SshBastionConf) GetLogForwarding() LogForwardingConfigPart {
	if o == nil || o.LogForwarding == nil {
		var ret LogForwardingConfigPart
		return ret
	}
	return *o.LogForwarding
}

// GetLogForwardingOk returns a tuple with the LogForwarding field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SshBastionConf) GetLogForwardingOk() (*LogForwardingConfigPart, bool) {
	if o == nil || o.LogForwarding == nil {
		return nil, false
	}
	return o.LogForwarding, true
}

// HasLogForwarding returns a boolean if a field has been set.
func (o *SshBastionConf) HasLogForwarding() bool {
	if o != nil && o.LogForwarding != nil {
		return true
	}

	return false
}

// SetLogForwarding gets a reference to the given LogForwardingConfigPart and assigns it to the LogForwarding field.
func (o *SshBastionConf) SetLogForwarding(v LogForwardingConfigPart) {
	o.LogForwarding = &v
}

// GetSessionTermination returns the SessionTermination field value if set, zero value otherwise.
func (o *SshBastionConf) GetSessionTermination() SshBastionSessionTermination {
	if o == nil || o.SessionTermination == nil {
		var ret SshBastionSessionTermination
		return ret
	}
	return *o.SessionTermination
}

// GetSessionTerminationOk returns a tuple with the SessionTermination field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SshBastionConf) GetSessionTerminationOk() (*SshBastionSessionTermination, bool) {
	if o == nil || o.SessionTermination == nil {
		return nil, false
	}
	return o.SessionTermination, true
}

// HasSessionTermination returns a boolean if a field has been set.
func (o *SshBastionConf) HasSessionTermination() bool {
	if o != nil && o.SessionTermination != nil {
		return true
	}

	return false
}

// SetSessionTermination gets a reference to the given SshBastionSessionTermination and assigns it to the SessionTermination field.
func (o *SshBastionConf) SetSessionTermination(v SshBastionSessionTermination) {
	o.SessionTermination = &v
}

func (o SshBastionConf) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.HideSessionRecording != nil {
		toSerialize["hide_session_recording"] = o.HideSessionRecording
	}
	if o.Kexalgs != nil {
		toSerialize["kexalgs"] = o.Kexalgs
	}
	if o.LogForwarding != nil {
		toSerialize["log_forwarding"] = o.LogForwarding
	}
	if o.SessionTermination != nil {
		toSerialize["session_termination"] = o.SessionTermination
	}
	return json.Marshal(toSerialize)
}

type NullableSshBastionConf struct {
	value *SshBastionConf
	isSet bool
}

func (v NullableSshBastionConf) Get() *SshBastionConf {
	return v.value
}

func (v *NullableSshBastionConf) Set(val *SshBastionConf) {
	v.value = val
	v.isSet = true
}

func (v NullableSshBastionConf) IsSet() bool {
	return v.isSet
}

func (v *NullableSshBastionConf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSshBastionConf(val *SshBastionConf) *NullableSshBastionConf {
	return &NullableSshBastionConf{value: val, isSet: true}
}

func (v NullableSshBastionConf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSshBastionConf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


